class BcmConfig {
    constructor(config) {
        this.config = config;
    }
    setConfig(config) {
        this.config = config;
    }
    getConfig() {
        console.log('config get: ' + JSON.stringify(this.config));
        return this.config;
    }
}

(() =>
    document.dispatchEvent(
        new CustomEvent('bcm-config', {
            detail: {
                isLoad: true,
            },
        }),
    ))();

// ! will be improve in the future
async function bcm(id, ms = 300) {
    let promise = new Promise(async function (resolve, reject) {
        let selector = document.getElementById(id);
        if (selector) {
            resolve(selector);
        } else {
            document.addEventListener('bcm-is-load', async e => {
                if (e.target.id == id) {
                    document.removeEventListener('bcm-is-load', e);
                    selector = document.getElementById(id);
                    return resolve(selector);
                }
                await new Promise(resolve => setTimeout(resolve, ms));
                document.removeEventListener('bcm-is-load', e);
            });
            await new Promise(resolve => setTimeout(resolve, ms));
            reject('Selector ' + id + ' not found');
        }
    });
    return promise;
}

