/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const bcm = require('./bcm-1d1fcf21.js');
require('./string-helper-9cdfb273.js');
const captionTemplate = require('./caption-template-85a18b6d.js');
require('./index-95ae50d0.js');
require('./types-cc4adee7.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
require('./types-7523fd99.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./package-033055fc.js');

const BcmCaption = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.noCaption = false;
    this.captionType = bcm.Bcm$1.Status.default;
    this.captionClasses = undefined;
    this.caption = undefined;
    this.captionError = undefined;
    this.customErrorMessage = undefined;
    this.size = bcm.Bcm$1.Size.medium;
    this.maxLength = undefined;
    this.value = undefined;
  }
  render() {
    const { noCaption, captionType, captionClasses, caption, captionError, customErrorMessage, size, maxLength, value } = this;
    return (index.h(index.Host, { class: "tw-block" }, index.h(captionTemplate.CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionClasses: captionClasses, caption: caption, captionError: captionError, customErrorMessage: customErrorMessage, size: size, maxLength: maxLength, value: value })));
  }
};

exports.bcm_caption = BcmCaption;
