/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const utils = require('./utils-fc077139.js');

const BcmCollapseGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.borderless = false;
    this.open = false;
    this.multiple = false;
    this.hidden = false;
  }
  handleOpen({ target, detail }) {
    if (!this.multiple && this.el === target.parentElement) {
      this.qs().forEach(child => {
        child.open = child.id === detail;
      });
    }
  }
  componentDidLoad() {
    this.qs().forEach((child, index) => {
      !child.borderless && (child.borderless = this.borderless);
      this.qs().length == index + 1 && (child.noBorder = true);
    });
  }
  qs() {
    return utils.getChildElements(this.el, 'bcm-collapse');
  }
  render() {
    const { hidden } = this;
    return (index.h(index.Host, { class: { hidden } }, index.h("slot", null)));
  }
  get el() { return index.getElement(this); }
};

exports.bcm_collapse_group = BcmCollapseGroup;
