/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const index$1 = require('./index-95ae50d0.js');
const colors = require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');

const BcmOverlay = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.center = false;
    this.color = colors.colors.black;
    this.opacity = "0.5";
    this.zIndex = "10400";
  }
  render() {
    return (index.h(index.Host, { class: index$1.classnames("tw-fixed tw-inset-0 tw-transition", {
        "tw-flex tw-items-center tw-justify-center": this.center,
      }), style: {
        backgroundColor: `${this.color}`,
        opacity: this.opacity,
        zIndex: this.zIndex,
      } }, index.h("slot", null)));
  }
};

const BcmScrollArea = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.width = "inherit";
    this.height = "inherit";
    this.isDisabled = false;
  }
  render() {
    return (index.h(index.Host, { class: index$1.classnames("tw-block", {
        "tw-overflow-y-scroll tw-overscroll-contain": !this.isDisabled,
      }), style: { width: this.width, height: this.height } }, index.h("slot", null)));
  }
};

exports.bcm_overlay = BcmOverlay;
exports.bcm_scroll_area = BcmScrollArea;
