/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const index$1 = require('./index-95ae50d0.js');
const generate = require('./generate-b43c3d3b.js');
const bcm = require('./bcm-1d1fcf21.js');
const utils = require('./utils-fc077139.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');

const rangeCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-range{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;width:100%;position:relative;display:block;margin:16px 0}.bcm-range input[type=range]{position:absolute;pointer-events:none;-webkit-appearance:none;z-index:4;height:30px;width:100%;top:-17px;opacity:0}.bcm-range input[type=range].single{display:none}.bcm-range input[type=range]::-webkit-slider-thumb{pointer-events:all;width:30px;height:30px;border-radius:0;border:0 none;background-color:red;-webkit-appearance:none;cursor:pointer}.bcm-range__container-bar{width:calc(100% - 24px);left:12px;position:relative}.bcm-range__container-bar-track{position:absolute;top:-2px;width:100%;height:4px;background-color:var(--bcm-new-ds-color-slate-300);z-index:1}.bcm-range__container-bar-range{position:absolute;top:-2px;left:22.22%;right:22.22%;height:4px;background-color:var(--bcm-new-ds-color-blue-500);z-index:2}.bcm-range__container-bar-thumb{position:absolute;top:0;width:16px;height:16px;background-color:var(--bcm-new-ds-color-blue-500);border-radius:50%;z-index:3;transition:box-shadow 0.2s ease-in-out;display:flex;align-items:center;justify-content:center}.bcm-range__container-bar-thumb>span{display:flex;width:100%;height:100%}.bcm-range__container-bar-thumb.hover{box-shadow:0px 2px 2px rgba(0, 0, 0, 0.1), 0px 3px 1px rgba(0, 0, 0, 0.05), 0px 1px 5px rgba(0, 0, 0, 0.1);cursor:pointer}.bcm-range__container-bar-thumb.hidden{display:none}.bcm-range__container-bar-thumb.left{left:22.22222%;transform:translate(-8px, -8px)}.bcm-range__container-bar-thumb.right{right:0%;transform:translate(8px, -8px)}.bcm-range .ticks{position:absolute;z-index:0;top:0;left:0;width:100%;display:flex;justify-content:space-between;padding:4px 0;user-select:none}.bcm-range .tick{position:relative;display:flex;justify-content:center;width:1px;color:var(--bcm-new-ds-color-slate-300);cursor:pointer;height:8px;line-height:32px;margin-bottom:8px;z-index:-1;transition:color 0.1s ease-in-out}.bcm-range .tick::before,.bcm-range .tick::after{content:\" \";position:absolute;width:1px;height:8px;background-color:var(--bcm-new-ds-color-slate-300);z-index:-1;transition:background-color 0.1s ease-in-out}.bcm-range .tick::before{top:-16px}.bcm-range .tick::after{top:0}.bcm-range .tick.hover{color:var(--bcm-new-ds-color-slate-400)}.bcm-range .tick.hover::before,.bcm-range .tick.hover::after{background-color:var(--bcm-new-ds-color-slate-400)}.bcm-range .touch{position:absolute;width:calc(100% + 48px);left:-24px;top:-17px;opacity:0;height:45px;z-index:2;background-color:transparent;display:flex;flex-direction:row;justify-content:space-between}.bcm-range .touch-point{cursor:pointer;flex:1;border:1px solid var(--bcm-new-ds-color-slate-300);box-sizing:border-box;background-color:var(--bcm-new-ds-color-slate-300)}.bcm-range .touch-point:hover{border-color:var(--bcm-new-ds-color-blue-500);background-color:var(--bcm-new-ds-color-blue-500)}.bcm-range .touch::after,.bcm-range .touch::before{content:\"\";position:absolute;width:24px;height:100%;top:0}.bcm-range .touch::before{left:0}.bcm-range .touch::after{right:0}.bcm-range.vertical{margin:0 16px;padding:12px 0}.bcm-range.vertical .touch{width:calc(100% + 12px);left:-6px;top:-17px}.bcm-range.vertical .touch::after,.bcm-range.vertical .touch::before{width:12px}.bcm-range.vertical .bcm-range__container{transform:rotate(270deg)}.bcm-range.vertical .bcm-range__container .ticks .tick-text{position:absolute;top:0px;width:100%;transform:rotate(90deg)}";

const BcmRange = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.change = index.createEvent(this, "bcm-change", 7);
    this._id = generate.Generate.UID();
    this.min = 0;
    this.max = 10;
    this.step = 1;
    this.value = 0;
    this.height = "326px";
    this.name = undefined;
    this.direction = bcm.Bcm$1.Direction.horizontal;
    this._prefix = undefined;
    this._suffix = undefined;
    this.multiple = false;
    this.leftValue = undefined;
    this.rightValue = undefined;
    this.leftMin = undefined;
  }
  connectedCallback() {
    const parsed = JSON.parse(this.value);
    this.value = typeof parsed === 'number' ? [parsed] : parsed;
    if (this.value.length > 1) {
      this.leftValue = this.value[0];
      this.rightValue = this.value[1];
      this.leftMin = this.min;
      this.multiple = true;
    }
    else {
      this.rightValue = this.value;
      this.leftMin = this.min - this.step;
      this.leftValue = this.leftMin;
      this.multiple = false;
    }
    generate.Generate.createComponent('bcm-tooltip-box', {
      id: 'box-' + this._id,
      placement: this.direction === bcm.Bcm$1.Direction.horizontal ? bcm.Bcm$1.Placement.top : bcm.Bcm$1.Placement.left,
      color: 'blue'
    });
  }
  componentDidLoad() {
    this.setThumbPosition('right');
    this.setThumbPosition('left');
    if (!this.multiple) {
      this.hiddenLeftThumb();
    }
  }
  async setValue(value) {
    this.value = value;
    this.handleChange();
    return value;
  }
  async setClear() {
    if (this.multiple) {
      this.value = [this.min, this.max];
    }
    else {
      this.value = this.min;
    }
    await utils.delay(10);
    return Promise.resolve();
  }
  async resetCaption() {
    await utils.delay(10);
    /* ???? */
    await utils.delay(10);
    return Promise.resolve();
  }
  async getValue() {
    return this.value;
  }
  syncValues(type, event) {
    const val = event.target.valueAsNumber;
    const other = type === 'left' ? this.rightValue : this.leftValue;
    if (type === 'left') {
      this.leftValue = val >= other ? other - 1 : val;
      this.getInput(type).valueAsNumber = this.leftValue;
      this.setThumbPosition('left');
    }
    else {
      this.rightValue = val <= other ? other + 1 : val;
      this.getInput(type).valueAsNumber = this.rightValue;
      this.setThumbPosition('right');
    }
  }
  handleChange() {
    if (this.multiple) {
      this.getInput('left').valueAsNumber = this.leftValue;
      this.getInput('right').valueAsNumber = this.rightValue;
      this.value = [this.leftValue, this.rightValue];
    }
    else {
      this.getInput('right').valueAsNumber = this.rightValue;
      this.value = this.rightValue;
    }
    this.change.emit(this.value);
  }
  setThumbPosition(type) {
    const { min, max } = this;
    const range = this.el.querySelector('#bcm-range__thumb-range');
    let percent;
    percent = ((this.getInput(type).valueAsNumber - min) / (max - min)) * 100;
    percent = (type === 'left' ? percent : 100 - percent) + '%';
    this.getThumb(type).style[type] = percent;
    range.style[type] = percent;
  }
  hiddenLeftThumb() {
    const thumb = this.getThumb('left');
    const range = this.el.querySelector('#bcm-range__thumb-range');
    thumb.classList.add('hidden');
    range.style.left = 0;
  }
  getTooltip(type) {
    const element = document.querySelector(`bcm-tooltip-box[id="box-${this._id}"]`);
    element.setAttribute('target-id', 'bcm-range__thumb-' + type + '-' + this._id);
    element.setAttribute('message', this.getInput(type).valueAsNumber);
    return element;
  }
  getThumb(type) {
    return this.el.querySelector('#bcm-range__thumb-' + type + '-' + this._id);
  }
  getInput(type) {
    return this.el.querySelector('#input-' + type + '-' + this._id);
  }
  touchToMove(value) {
    const closest = this.multiple && Math.abs(value - this.leftValue) < Math.abs(value - this.rightValue) ? 'left' : 'right';
    this.getInput(closest).valueAsNumber = value;
    this.syncValues(closest, { target: { valueAsNumber: value } });
    this.handleChange();
  }
  hoverTick(id, status) {
    const tick = this.el.querySelector(`#tick-${id}`);
    tick.classList.toggle('hover', status);
  }
  render() {
    const { min, max, step, leftMin, direction, height } = this;
    const hostClasses = index$1.classnames('bcm-range', direction);
    const Ticks = () => {
      const { min, max, step, _prefix, _suffix } = this;
      const trackBarLiElement = [];
      for (let i = min; i <= max; i += step) {
        trackBarLiElement.push(index.h("span", { id: 'tick-' + i, class: "tick size-1" }, index.h("span", { class: "tick-text", onMouseOver: () => this.hoverTick(i, true), onMouseOut: () => this.hoverTick(i, false), onClick: () => this.touchToMove(i) }, _prefix, i, _suffix)));
      }
      return trackBarLiElement;
    };
    const Touch = () => {
      const { min, max, step } = this;
      const trackBarLiElement = [];
      for (let i = min; i <= max; i += step) {
        trackBarLiElement.push(index.h("span", { onMouseOver: () => this.hoverTick(i, true), onMouseOut: () => this.hoverTick(i, false), onClick: () => this.touchToMove(i), class: "touch-point" }));
      }
      return trackBarLiElement;
    };
    const verticalStyle = {
      height: '100%',
      width: height,
    };
    return (index.h(index.Host, { class: hostClasses, style: direction == bcm.Bcm$1.Direction.vertical && { height: height } }, index.h("div", { class: "bcm-range__container", style: direction == bcm.Bcm$1.Direction.vertical && verticalStyle }, index.h("input", { type: "range", role: "slider", "aria-label": "range", id: `input-left-${this._id}`, min: leftMin, max: max, step: step, onChange: (event) => { this.syncValues('left', event); this.handleChange(); }, onInput: (event) => { this.syncValues('left', event); this.getTooltip('left').hide(); this.getTooltip('left').show(); }, onMouseOver: () => { this.getThumb('left').classList.add('hover'); this.getTooltip('left').show(); }, onMouseOut: () => { this.getThumb('left').classList.remove('hover'); this.getTooltip('left').hide(); }, value: this.leftValue, class: { 'single': !this.multiple } }), index.h("input", { type: "range", id: `input-right-${this._id}`, role: "slider", "aria-label": "range", min: min, max: max, onChange: (event) => { this.syncValues('right', event); this.handleChange(); }, onInput: (event) => { this.syncValues('right', event); this.getTooltip('right').hide(); this.getTooltip('right').show(); }, onMouseOver: () => { this.getThumb('right').classList.add('hover'); this.getTooltip('right').show(); }, onMouseOut: () => { this.getThumb('right').classList.remove('hover'); this.getTooltip('right').hide(); }, step: step, value: this.rightValue }), index.h("div", { class: "bcm-range__container-bar" }, index.h("div", { class: "ticks" }, index.h(Ticks, null)), index.h("div", { class: "bcm-range__container-bar-track" }), index.h("div", { class: "bcm-range__container-bar-range", id: "bcm-range__thumb-range" }), index.h("div", { class: "bcm-range__container-bar-thumb left", id: `bcm-range__thumb-left-${this._id}` }, index.h("span", null)), index.h("div", { class: "bcm-range__container-bar-thumb right", id: `bcm-range__thumb-right-${this._id}` }, index.h("span", null))), index.h("div", { class: "touch" }, index.h(Touch, null)))));
  }
  get el() { return index.getElement(this); }
};
BcmRange.style = rangeCss;

exports.bcm_range = BcmRange;
