/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const types = require('./types-3871235f.js');
const index$1 = require('./index-95ae50d0.js');
require('./_commonjsHelpers-ed84c3ca.js');

const tabCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}:host{display:block}:host(.hidden){display:none}slot[name=icon-suffix]::slotted(bcm-icon){margin-left:10px}slot[name=icon-prefix]::slotted(bcm-icon){margin-right:10px}.tab{font-family:Inter, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, Segoe UI, Roboto, Helvetica Neue, Arial, Noto Sans, sans-serif, Apple Color Emoji, Segoe UI Emoji, Segoe UI Symbol, Noto Color Emoji;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale;position:relative;display:flex;flex-direction:row;align-items:center;justify-content:center;flex-wrap:nowrap;padding:var(--bcm-tab-vertical-space) 14px var(--bcm-tab-vertical-space) 14px;color:#374151;font-size:14px;line-height:20px;font-weight:500;cursor:pointer;user-select:none}.tab:hover{color:#1f2937}.tab:active{color:#1f2937}.tab:focus-visible{color:#1f2937}.tab.active{color:#1d4ed8}.tab.active::before{content:\"\";bottom:-2px;left:0;width:100%;height:2px;background-color:#1d4ed8;position:absolute;z-index:1}.tab.active:hover{color:#1e40af}.tab.active:active{color:#1e40af}.tab.active:focus-visible{color:#1e40af}.tab:active,.tab:focus{color:var(--bcm-color-prime-blue-7)}.tab[disabled],.tab.disabled{color:var(--bcm-color-grey-6);cursor:not-allowed}.tab.closable:not(.pane){padding-left:0;padding-right:0}.tab.closable .close{margin-left:34px}.tab.pane{border:1px solid transparent;border-bottom:none;border-color:var(--bcm-color-grey-5);background-color:var(--bcm-color-grey-3);border-radius:2px 2px 0 0}.tab.pane.active{background-color:#ffffff}.badge{padding-left:8px;position:relative}.badge.blink:after{content:\"\";position:absolute;top:8px;left:9px;background:black;border-radius:50%;height:7px;width:7px;box-shadow:0 0 0 0 rgba(0, 0, 0, 0);transform:scale(1)}.badge.success:after{animation:pulsesuccess 2s infinite;background-color:#52C41A}.badge.error:after{animation:pulseerror 2s infinite;background-color:#F5222D}.badge.default:after{animation:pulsedefault 2s infinite;background-color:#D9D9D9}.badge.processing:after{animation:pulseprocessing 2s infinite;background-color:#4293CF}.badge.warning:after{animation:pulsewarning 2s infinite;background-color:#FA8C16}@keyframes pulsesuccess{0%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(82, 196, 26, 0.7)}70%{transform:scale(1);box-shadow:0 0 0 10px rgba(0, 0, 0, 0)}100%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(0, 0, 0, 0)}}@keyframes pulseerror{0%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(245, 34, 45, 0.7)}70%{transform:scale(1);box-shadow:0 0 0 10px rgba(0, 0, 0, 0)}100%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(0, 0, 0, 0)}}@keyframes pulsedefault{0%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(217, 217, 217, 0.7)}70%{transform:scale(1);box-shadow:0 0 0 10px rgba(0, 0, 0, 0)}100%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(0, 0, 0, 0)}}@keyframes pulseprocessing{0%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(66, 147, 207, 0.7)}70%{transform:scale(1);box-shadow:0 0 0 10px rgba(0, 0, 0, 0)}100%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(0, 0, 0, 0)}}@keyframes pulsewarning{0%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(250, 140, 22, 0.7)}70%{transform:scale(1);box-shadow:0 0 0 10px rgba(0, 0, 0, 0)}100%{transform:scale(0.95);box-shadow:0 0 0 0 rgba(0, 0, 0, 0)}}";

const BcmTab = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.click = index.createEvent(this, "bcm-click", 7);
    this.close = index.createEvent(this, "bcm-close", 7);
    this.type = types.TypeProps.normal;
    this.active = false;
    this.disabled = false;
    this.closable = false;
    this.tabId = (Math.random() * 4).toString(16).replace('.', '');
    this.formControl = null;
    this.hidden = false;
    this.status = 'default';
    this.badge = false;
    this.blink = false;
  }
  /**
   * @desc
   */
  handleClose() {
    if (this.disabled)
      return;
    this.close.emit();
  }
  /**
   * @desc
   * @param event
   */
  handleClick(event) {
    if (this.disabled)
      return;
    const targetElement = event.target;
    // Detect close icon clicked
    // #
    if (String(targetElement.tagName).toLowerCase() == 'bcm-icon' && targetElement.classList.contains('close')) {
      this.close.emit(event);
    }
    else {
      this.click.emit(event);
    }
  }
  render() {
    const { active, disabled, closable } = this;
    const classes = index$1.classnames('tab', [this.type], {
      'active': active,
      'disabled': disabled,
      'closable': closable
    });
    const hostClasses = index$1.classnames(this.hidden ? 'hidden' : null);
    const badgeClasses = index$1.classnames('badge');
    return (index.h(index.Host, { class: hostClasses }, index.h("div", { class: classes, onClick: (event) => this.handleClick(event) }, index.h("slot", { name: "icon-prefix" }), index.h("slot", null), index.h("slot", { name: "icon-suffix" }), this.closable && (index.h("bcm-icon", { class: "close", icon: "far fa-times" })), this.badge && (index.h("bcm-badge", { blink: true, class: badgeClasses, size: "small", status: this.status })))));
  }
  get el() { return index.getElement(this); }
};
BcmTab.style = tabCss;

exports.bcm_tab = BcmTab;
