/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

const index = require('./index-c591ecec.js');
const _package = require('./package-033055fc.js');
const watermark = require('./watermark-2c23c8f1.js');

window.bcm = (function () {
  return {
    version: _package.version,
  };
})();
function addHeadScript(obj) {
  const head = document.head;
  const script = document.createElement("script");
  Object.keys(obj).forEach(key => {
    script[key] = obj[key];
  });
  head.appendChild(script);
}
addHeadScript({ src: "https://kit.fontawesome.com/5e86bea963.js", crossOrigin: "anonymous" });
(() => {
  watermark.LicenseManager.setLicenseKey(index.Env["AG_GRID_LICENSE_KEY"]);
})();
