/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

const index = require('./index-c591ecec.js');
const index$1 = require('./index-95ae50d0.js');
const bcm = require('./bcm-1d1fcf21.js');

const LabelTemplate = ({ required, value, size, form, htmlFor, type, tooltip }) => {
  size = size || "medium";
  type = type || bcm.Bcm$1.Status.default;
  return (index.h("label", { form: form, htmlFor: htmlFor, "aria-hidden": "true", class: index$1.classnames("bcm-ui-element bcm-ui-feedback bcm-label bcm-label__text tw-mb-1 tw-font-medium tw-text-slate-600 ", {
      "tw-text-1": size == "small",
      "tw-text-2": size == "medium",
      "tw-text-3": size == "large",
    }) },
    value,
    " ",
    required && "*",
    tooltip && (index.h("span", { class: "tw-ml-1" },
      index.h("bcm-tooltip", { message: tooltip, placement: "top", trigger: "hover" },
        index.h("bcm-icon", { icon: "fas fa-info-circle" }))))));
};

exports.LabelTemplate = LabelTemplate;
