/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

const generate = require('./generate-b43c3d3b.js');

class NumberHelper {
}
NumberHelper.isNumber = (str) => generate.snq(() => /^[0-9]+$/i.test(str));
NumberHelper.convertToNumber = (str) => generate.snq(() => Number(str));
NumberHelper.replaceNumber = (str) => generate.snq(() => str.replace(/[^0-9]/g, ''));
NumberHelper.replaceFloat = (str) => generate.snq(() => str.replace(/[^0-9.]/g, ''));
NumberHelper.toFixed = (num, fixed) => generate.snq(() => num.toFixed(fixed));
NumberHelper.parseFloatFixed = (str, fixed) => generate.snq(() => parseFloat(NumberHelper.replaceFloat(str)).toFixed(fixed));
NumberHelper.getDecimalLength = (str) => generate.snq(() => str.split('.')[1] ? str.split('.')[1].length : 0);
NumberHelper.toNumber = (str) => generate.snq(() => Number(str.replace(/[^0-9.]/g, '')));

exports.NumberHelper = NumberHelper;
