/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

const index = require('./index-c591ecec.js');
const stringHelper = require('./string-helper-9cdfb273.js');

const SlotTemplate = ({ value, className, name }) => {
  return stringHelper.StringHelper.isNullOrEmpty(value) ? index.h("span", { class: className },
    index.h("slot", Object.assign({}, (name && { name: name })))) : index.h("span", { class: className, innerHTML: value });
};

exports.SlotTemplate = SlotTemplate;
