/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { tv } from "tailwind-variants";
export const avatarStyle = tv({
  slots: {
    base: "bcm-avatar bcm-ui-element bcm-ui-content-display tw-uppercase tw-inline-flex tw-items-center tw-justify-center tw-bg-[--bcm-avatar-bg] tw-text-[--bcm-avatar-text]",
    image: "tw-w-full tw-h-full",
    badge: "",
  },
  variants: {
    size: {
      small: "bcm-avatar__size-small tw-text-1 tw-w-6 tw-h-6",
      medium: "bcm-avatar__size-medium tw-text-2 tw-w-8 tw-h-8",
      large: "bcm-avatar__size-large tw-text-3 tw-w-10 tw-h-10",
    },
    shape: {
      ellipse: {
        base: "bcm-avatar__shape-ellipse tw-rounded-full",
        image: "tw-rounded-full",
        badge: "tw-top-0 tw-right-0",
      },
      square: {
        base: "bcm-avatar__shape-square tw-rounded",
        image: "tw-rounded",
        badge: "tw--top-0.5 tw--right-0.5",
      },
    },
    status: {
      true: {
        base: "bcm-avatar__status tw-relative",
        badge: "tw-absolute",
      },
    },
  },
  defaultVariants: {
    size: "medium",
    shape: "ellipse",
    status: false,
  },
});
