/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
export const variantOptions = {
  save: {
    text: 'Save',
    color: 'emerald',
    icon: 'far fa-save',
    iconPosition: 'prefix',
  },
  ok: {
    text: 'Ok',
    color: 'emerald',
    icon: 'far fa-check',
    iconPosition: 'prefix',
  },
  new: {
    text: 'New',
    color: 'emerald',
    icon: 'far fa-plus',
    iconPosition: 'prefix',
  },
  add: {
    text: 'Add',
    color: 'emerald',
    icon: 'far fa-plus',
    iconPosition: 'prefix',
  },
  create: {
    text: 'Create',
    color: 'emerald',
    icon: 'far fa-plus',
    iconPosition: 'prefix',
  },
  prev: {
    text: 'Prev',
    color: '',
    icon: 'far fa-arrow-left',
    iconPosition: 'prefix',
  },
  next: {
    text: 'Next',
    color: '',
    icon: 'far fa-arrow-right',
    iconPosition: 'suffix',
  },
  apply: {
    text: 'Apply',
    color: '',
    icon: 'far fa-check-circle',
    iconPosition: 'prefix',
  },
  submit: {
    text: 'Submit',
    color: '',
    icon: 'far fa-save',
    iconPosition: 'prefix',
  },
  send: {
    text: 'Send',
    color: 'emerald',
    icon: 'far fa-paper-plane',
    iconPosition: 'prefix',
  },
  delete: {
    text: 'Delete',
    color: 'red',
    icon: 'far fa-trash',
    iconPosition: 'prefix',
  },
  cancel: {
    text: 'Cancel',
    color: 'red',
    icon: 'far fa-times',
    iconPosition: 'prefix',
  },
  decline: {
    text: 'Decline',
    color: 'red',
    icon: 'far fa-ban',
    iconPosition: 'prefix',
  },
  close: {
    text: 'Close',
    color: 'red',
    icon: 'far fa-times-circle',
    iconPosition: 'prefix',
  },
  archive: {
    text: 'Archive',
    color: 'red',
    icon: 'far fa-folder-open',
    iconPosition: 'prefix',
  },
  remove: {
    text: 'Remove',
    color: 'red',
    icon: 'far fa-minus-circle',
    iconPosition: 'prefix',
  },
  edit: {
    text: 'Edit',
    color: '',
    icon: 'far fa-edit',
    iconPosition: 'prefix',
  },
  export: {
    text: 'Export',
    color: '',
    icon: 'far fa-sign-out',
    iconPosition: 'prefix',
  },
  import: {
    text: 'Import',
    color: '',
    icon: 'far fa-sign-in',
    iconPosition: 'prefix',
  },
  filter: {
    text: 'Filter',
    color: '',
    icon: 'far fa-filter',
    iconPosition: 'prefix',
  },
  update: {
    text: 'Update',
    color: '',
    icon: 'far fa-sync',
    iconPosition: 'prefix',
  },
  reset: {
    text: "Reset",
    color: "",
    icon: 'far fa-sync',
    iconPosition: "prefix",
  },
  download: {
    text: 'Download',
    color: '',
    icon: 'far fa-download',
    iconPosition: 'prefix',
  },
};
export var VariantProps;
(function (VariantProps) {
  VariantProps["save"] = "save";
  VariantProps["submit"] = "submit";
  VariantProps["ok"] = "ok";
  VariantProps["new"] = "new";
  VariantProps["add"] = "add";
  VariantProps["create"] = "create";
  VariantProps["apply"] = "apply";
  VariantProps["prev"] = "prev";
  VariantProps["next"] = "next";
  VariantProps["send"] = "send";
  VariantProps["delete"] = "delete";
  VariantProps["cancel"] = "cancel";
  VariantProps["decline"] = "decline";
  VariantProps["close"] = "close";
  VariantProps["archive"] = "archive";
  VariantProps["remove"] = "remove";
  VariantProps["edit"] = "edit";
  VariantProps["export"] = "export";
  VariantProps["import"] = "import";
  VariantProps["filter"] = "filter";
  VariantProps["update"] = "update";
  VariantProps["reset"] = "Reset";
  VariantProps["download"] = "download";
})(VariantProps || (VariantProps = {}));
