/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { tv } from "tailwind-variants";
export const skeletonStyle = tv({
  slots: {
    host: "tw-flex tw-flex-row tw-items-center tw-justify-center tw-flex-shrink-0 tw-relative tw-overflow-hidden tw-bg-gray-200",
  },
  variants: {
    variant: {
      rect: {
        host: "tw-rounded",
      },
      circle: {
        host: "tw-rounded-full",
      },
    },
    effect: {
      pulse: {
        host: "tw-animate-pulse",
      },
      ping: {
        host: "tw-animate-ping",
      },
      none: {
        host: "tw-animate-none",
      },
    },
    hidden: {
      true: {
        host: "tw-hidden",
      },
      false: {
        host: "tw-flex",
      },
    }
  },
  defaultVariants: {
    variant: "rect",
    effect: "pulse",
    hidden: false,
  },
});
