/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { createStore } from "@stencil/store";
import { Generate } from "../../../helper/generate";
import snq from "snq";
const { state } = createStore({
  value: new Map(),
  setData: {},
  removeData: {}
});
const setValue = (val) => {
  const data = Object.assign(Object.assign(Object.assign({}, val), { size: val.bigIcon ? 'medium' : 14, iconType: val.bigIcon ? 'outlined' : 'fill' }), Generate.getIconAttrWithStatusType(val.status));
  state.value.set(data.id, data);
};
const removeValue = (_id) => {
  state.value.delete(_id);
};
const getValue = (id) => snq(() => state.value.get(id), {});
export default {
  setValue,
  removeValue,
  getValue
};
