/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { tv } from "tailwind-variants";
export const attendanceActionDropdownStyle = tv({
  slots: {
    host: [
      "tw-w-fit",
      "tw-absolute tw-left-0 tw-right-0 tw-z-tooltip tw-opacity-100 tw-transition-opacity tw-duration-300",
      "tw-overscroll-contain  tw-scroll-smooth tw-rounded tw-bg-white tw-shadow tw-max-h-64 tw-overflow-y-auto",
      "bcm-ui-element bcm-attendance-actions tw-flex tw-flex-col tw-items-start tw-justify-start tw-p-2 tw-font-medium tw-text-slate-700"
    ],
    dataItem: ["tw-flex tw-w-full tw-cursor-pointer tw-flex-row tw-items-start tw-justify-start tw-gap-2 tw-rounded  hover:tw-bg-blue-100"],
    key: ["tw-font-mono tw-text-slate-600"],
    selectedItem: ["tw-bg-blue-100"],
  },
  variants: {
    size: {
      small: {
        dataItem: ["tw-text-2.5 tw-px-2.5 tw-py-2"],
      },
      medium: {
        dataItem: ["tw-text-3 tw-px-3 tw-py-2"],
      },
      large: {
        dataItem: ["tw-text-4 tw-px-4 tw-py-2"],
      },
    }
  },
  defaultVariants: {
    size: "medium"
  },
});
