/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import { Generate } from '../../../helper/generate';
export class BcmDefault {
  constructor() {
    this._id = Generate.UID();
  }
  render() {
    return (h(Host, null, h("bcm-skeleton", null, h("slot", null))));
  }
  static get is() { return "bcm-default"; }
  static get originalStyleUrls() {
    return {
      "$": ["default.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["default.css"]
    };
  }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      }
    };
  }
  static get elementRef() { return "el"; }
}
