/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate } from "@bcm/helpers";
import { Host, h } from "@stencil/core";
export class BcmModal2Header {
  constructor() {
    this._id = Generate.UID();
    this.el.slot = "header";
  }
  render() {
    return (h(Host, { class: "tw-w-full tw-flex-none tw-overflow-hidden tw-rounded-t-lg tw-bg-primary-400 tw-pt-1" }, h("div", { class: "tw-flex tw-w-full tw-items-center tw-justify-between tw-bg-primary-50 tw-px-4 tw-py-3 tw-text-4 tw-font-medium tw-text-slate-600" }, h("span", null, h("slot", null)), h("button", { type: "button", class: "tw-focus:tw-outline-none tw-flex tw-h-8 tw-w-8 tw-cursor-pointer tw-items-center tw-justify-center tw-bg-transparent tw-text-5 tw-text-slate-700 tw-transition tw-duration-150 tw-ease-in-out hover:tw-text-slate-900", "data-dismiss": true }, h("i", { class: "far fa-times" })))));
  }
  static get is() { return "bcm-modal-2-header"; }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      }
    };
  }
  static get elementRef() { return "el"; }
}
