/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import snq from "snq";
export class NumberHelper {
}
NumberHelper.isNumber = (str) => snq(() => /^[0-9]+$/i.test(str));
NumberHelper.convertToNumber = (str) => snq(() => Number(str));
NumberHelper.replaceNumber = (str) => snq(() => str.replace(/[^0-9]/g, ''));
NumberHelper.replaceFloat = (str) => snq(() => str.replace(/[^0-9.]/g, ''));
NumberHelper.toFixed = (num, fixed) => snq(() => num.toFixed(fixed));
NumberHelper.parseFloatFixed = (str, fixed) => snq(() => parseFloat(NumberHelper.replaceFloat(str)).toFixed(fixed));
NumberHelper.getDecimalLength = (str) => snq(() => str.split('.')[1] ? str.split('.')[1].length : 0);
NumberHelper.toNumber = (str) => snq(() => Number(str.replace(/[^0-9.]/g, '')));
