/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import cs from 'classnames';
export const IconTemplate = ({ icon, hidden }) => {
  const replaceIcon = (icon) => {
    if (icon && icon.indexOf('fa-') > -1) {
      const split = icon.split(" ");
      let prefix = split[0].replace(/^fa/g, "bcm-fa");
      let iconName = split[1].replace(/^fa-/g, "bcm-fa-");
      if (split[2]) {
        iconName += " " + split[2].replace(/^fa-/g, "bcm-fa-");
      }
      return prefix + " " + iconName;
    }
    return icon;
  };
  const hostClasses = cs('bcm-icon', replaceIcon(icon), {
    hidden,
  });
  return (h("span", { class: hostClasses }));
};
