/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from "@stencil/core";
import cs from "classnames";
import Bcm from "../models/bcm";
export const LabelTemplate = ({ required, value, size, form, htmlFor, type, tooltip }) => {
  size = size || "medium";
  type = type || Bcm.Status.default;
  return (h("label", { form: form, htmlFor: htmlFor, "aria-hidden": "true", class: cs("bcm-ui-element bcm-ui-feedback bcm-label bcm-label__text tw-mb-1 tw-font-medium tw-text-slate-600 ", {
      "tw-text-1": size == "small",
      "tw-text-2": size == "medium",
      "tw-text-3": size == "large",
    }) }, value, " ", required && "*", tooltip && (h("span", { class: "tw-ml-1" }, h("bcm-tooltip", { message: tooltip, placement: "top", trigger: "hover" }, h("bcm-icon", { icon: "fas fa-info-circle" }))))));
};
