/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { StringHelper } from "@bcm/helpers";
import { Fragment, h } from "@stencil/core";
export const ToolbarHamburgerTemplate = ({ hamburgerMenuId, config, column, extensions, onHideColumn, onSelectExportType }) => {
  const { showColumnButton, showExportButton, showNewButton } = config;
  return (h(Fragment, null, h("bcm-linked", { class: "lg:tw-hidden md:tw-hidden", "target-id": hamburgerMenuId, "main-linked": true }, h("div", { class: "tw-shadow-custom tw-w-full tw-min-w-[180px] tw-flex-col tw-gap-2 tw-p-4" }, showNewButton && (h("bcm-item", { color: "white" }, h("div", { class: "tw-flex tw-h-5 tw-w-full tw-flex-1 tw-items-center tw-justify-between tw-gap-1" }, h("span", null, "New")))), showColumnButton && (h("bcm-item", { id: hamburgerMenuId + "-hamburger-linked", color: "white" }, h("div", { class: "tw-flex tw-h-5 tw-w-full tw-flex-1 tw-items-center tw-justify-between tw-gap-1" }, h("span", { class: "tw-mr-2" }, "Add Column"), h("i", { class: "fas fa-chevron-right" })))), showExportButton && (h("bcm-item", { id: hamburgerMenuId + "-hamburger-extentions", color: "white" }, h("div", { class: "tw-flex tw-h-5 tw-w-full tw-flex-1 tw-items-center tw-justify-between tw-gap-1" }, h("span", { class: "tw-mr-2" }, "Exports"), h("i", { class: "fas fa-chevron-right" })))))), h("bcm-linked", { trigger: "hover", "target-id": hamburgerMenuId + "-hamburger-linked", placement: "left-start", "hide-delay": "200" }, h(Fragment, null, h("div", { class: "tw-shadow-custom tw-w-full tw-min-w-[200px] tw-flex-col tw-gap-2 tw-p-4" }, column === null || column === void 0 ? void 0 : column.map(col => {
    return (h("bcm-item", { color: "white" }, h("div", { class: "tw-flex tw-h-5 tw-w-full tw-flex-1 tw-items-center tw-justify-between tw-gap-1" }, h("span", null, StringHelper.capitalize(col.id)), h("bcm-switch", { disabled: col.disabled, accessKey: col.id, id: col.id, class: "tw-mt-2", "no-caption": true, checked: true, "onBcm-change": e => onHideColumn({ checked: e.detail, id: col.id }) }))));
  })))), h("bcm-linked", { trigger: "hover", "target-id": hamburgerMenuId + "-hamburger-extentions", placement: "left-start", "hide-delay": "200" }, h(Fragment, null, h("div", { class: "tw-shadow-custom tw-flex tw-w-full tw-min-w-[200px] tw-flex-col tw-gap-2 tw-p-4" }, extensions === null || extensions === void 0 ? void 0 : extensions.map(ext => {
    return (h("div", { class: "tw-flex tw-w-full tw-flex-1 tw-cursor-pointer tw-flex-row tw-items-center tw-justify-start tw-gap-2 tw-rounded tw-bg-white tw-px-3 tw-py-[5px] tw-font-sans tw-text-size-4 tw-font-medium tw-antialiased hover:tw-bg-slate-100", onClick: () => onSelectExportType(ext) }, h("span", null, h("i", { class: "tw-text-size-5 " + ext.icon })), h("span", null, ext.text)));
  }))))));
};
