/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import './color-helper.js';
import './validators.js';
import { G as Generate } from './generate.js';
import './number-helper.js';
import './string-helper.js';
import './element-dragger.js';
import './bcm.js';
import { c as classnames } from './index2.js';

const BcmModal2Footer$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this._id = Generate.UID();
    this.el.slot = "footer";
  }
  render() {
    return (h(Host, { class: classnames("tw-flex tw-flex-row tw-items-center tw-justify-end tw-gap-2 tw-px-6 tw-pb-6 tw-pt-2") }, h("slot", null)));
  }
  get el() { return this; }
}, [4, "bcm-modal-2-footer", {
    "_id": [1537, "id"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-modal-2-footer"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-modal-2-footer":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmModal2Footer$1);
      }
      break;
  } });
}

const BcmModal2Footer = BcmModal2Footer$1;
const defineCustomElement = defineCustomElement$1;

export { BcmModal2Footer, defineCustomElement };
