/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
var Bcm;
(function (Bcm) {
  (function (HtmlElementType) {
    HtmlElementType["div"] = "div";
    HtmlElementType["span"] = "span";
    HtmlElementType["button"] = "button";
    HtmlElementType["a"] = "a";
    HtmlElementType["input"] = "input";
    HtmlElementType["textarea"] = "textarea";
    HtmlElementType["select"] = "select";
    HtmlElementType["option"] = "option";
    HtmlElementType["img"] = "img";
    HtmlElementType["table"] = "table";
    HtmlElementType["tr"] = "tr";
    HtmlElementType["td"] = "td";
    HtmlElementType["th"] = "th";
    HtmlElementType["tbody"] = "tbody";
    HtmlElementType["thead"] = "thead";
    HtmlElementType["tfoot"] = "tfoot";
    HtmlElementType["ul"] = "ul";
    HtmlElementType["li"] = "li";
    HtmlElementType["form"] = "form";
    HtmlElementType["label"] = "label";
    HtmlElementType["main"] = "main";
    HtmlElementType["header"] = "header";
    HtmlElementType["footer"] = "footer";
    HtmlElementType["section"] = "section";
    HtmlElementType["article"] = "article";
    HtmlElementType["nav"] = "nav";
    HtmlElementType["aside"] = "aside";
  })(Bcm.HtmlElementType || (Bcm.HtmlElementType = {}));
  (function (Status) {
    Status["info"] = "info";
    Status["error"] = "error";
    Status["warning"] = "warning";
    Status["success"] = "success";
    Status["default"] = "default";
  })(Bcm.Status || (Bcm.Status = {}));
  (function (Shape) {
    Shape["ellipse"] = "ellipse";
    Shape["square"] = "square";
  })(Bcm.Shape || (Bcm.Shape = {}));
  (function (Direction) {
    Direction["horizontal"] = "horizontal";
    Direction["vertical"] = "vertical";
  })(Bcm.Direction || (Bcm.Direction = {}));
  (function (PreDefinedIconSize) {
    PreDefinedIconSize[PreDefinedIconSize["large"] = 48] = "large";
    PreDefinedIconSize[PreDefinedIconSize["medium"] = 24] = "medium";
    PreDefinedIconSize[PreDefinedIconSize["default"] = 16] = "default";
    PreDefinedIconSize[PreDefinedIconSize["small"] = 12] = "small";
    PreDefinedIconSize[PreDefinedIconSize["xsmall"] = 8] = "xsmall";
  })(Bcm.PreDefinedIconSize || (Bcm.PreDefinedIconSize = {}));
  (function (BaseSize) {
    BaseSize["small"] = "small";
    BaseSize["medium"] = "medium";
    BaseSize["large"] = "large";
  })(Bcm.BaseSize || (Bcm.BaseSize = {}));
  (function (Size) {
    Size["small"] = "small";
    Size["medium"] = "medium";
    Size["large"] = "large";
    Size["xsmall"] = "xsmall";
    Size["xlarge"] = "xlarge";
    Size["xxlarge"] = "xxlarge";
    Size["xxxlarge"] = "xxxlarge";
  })(Bcm.Size || (Bcm.Size = {}));
  (function (Kind) {
    Kind["solid"] = "solid";
    Kind["ghost"] = "ghost";
    Kind["link"] = "link";
    Kind["ghost-link"] = "ghost-link";
  })(Bcm.Kind || (Bcm.Kind = {}));
  (function (ButtonType) {
    ButtonType["button"] = "button";
    ButtonType["reset"] = "reset";
    ButtonType["submit"] = "submit";
  })(Bcm.ButtonType || (Bcm.ButtonType = {}));
  (function (IconPosition) {
    IconPosition["prefix"] = "prefix";
    IconPosition["suffix"] = "suffix";
  })(Bcm.IconPosition || (Bcm.IconPosition = {}));
  (function (TagType) {
    TagType["basic"] = "basic";
    TagType["add"] = "add";
    TagType["checkable"] = "checkable";
    TagType["dismissable"] = "dismissable";
  })(Bcm.TagType || (Bcm.TagType = {}));
  (function (FontSize) {
    FontSize["size-1"] = "size-1";
    FontSize["size-2"] = "size-2";
    FontSize["size-3"] = "size-3";
    FontSize["size-4"] = "size-4";
    FontSize["size-5"] = "size-5";
    FontSize["size-6"] = "size-6";
    FontSize["size-7"] = "size-7";
    FontSize["size-8"] = "size-8";
    FontSize["size-9"] = "size-9";
  })(Bcm.FontSize || (Bcm.FontSize = {}));
  (function (FontSizeValue) {
    FontSizeValue[FontSizeValue["size-1"] = 12] = "size-1";
    FontSizeValue[FontSizeValue["size-2"] = 14] = "size-2";
    FontSizeValue[FontSizeValue["size-3"] = 16] = "size-3";
    FontSizeValue[FontSizeValue["size-4"] = 20] = "size-4";
    FontSizeValue[FontSizeValue["size-5"] = 24] = "size-5";
    FontSizeValue[FontSizeValue["size-6"] = 30] = "size-6";
    FontSizeValue[FontSizeValue["size-7"] = 38] = "size-7";
    FontSizeValue[FontSizeValue["size-8"] = 46] = "size-8";
    FontSizeValue[FontSizeValue["size-9"] = 56] = "size-9";
  })(Bcm.FontSizeValue || (Bcm.FontSizeValue = {}));
  (function (FontWeight) {
    FontWeight["thin"] = "thin";
    FontWeight["light"] = "light";
    FontWeight["regular"] = "regular";
    FontWeight["medium"] = "medium";
    FontWeight["bold"] = "bold";
    FontWeight["black"] = "black";
  })(Bcm.FontWeight || (Bcm.FontWeight = {}));
  (function (ColorPalette) {
    ColorPalette["default"] = "default";
    ColorPalette["black"] = "black";
    ColorPalette["white"] = "white";
    ColorPalette["prime-blue"] = "prime-blue";
    ColorPalette["prime-blue-1"] = "prime-blue-1";
    ColorPalette["prime-blue-2"] = "prime-blue-2";
    ColorPalette["prime-blue-3"] = "prime-blue-3";
    ColorPalette["prime-blue-4"] = "prime-blue-4";
    ColorPalette["prime-blue-5"] = "prime-blue-5";
    ColorPalette["prime-blue-6"] = "prime-blue-6";
    ColorPalette["prime-blue-7"] = "prime-blue-7";
    ColorPalette["prime-blue-8"] = "prime-blue-8";
    ColorPalette["prime-blue-9"] = "prime-blue-9";
    ColorPalette["prime-blue-10"] = "prime-blue-10";
    ColorPalette["grey"] = "grey";
    ColorPalette["grey-1"] = "grey-1";
    ColorPalette["grey-2"] = "grey-2";
    ColorPalette["grey-3"] = "grey-3";
    ColorPalette["grey-4"] = "grey-4";
    ColorPalette["grey-5"] = "grey-5";
    ColorPalette["grey-6"] = "grey-6";
    ColorPalette["grey-7"] = "grey-7";
    ColorPalette["grey-8"] = "grey-8";
    ColorPalette["grey-9"] = "grey-9";
    ColorPalette["grey-10"] = "grey-10";
    ColorPalette["blue"] = "blue";
    ColorPalette["blue-1"] = "blue-1";
    ColorPalette["blue-2"] = "blue-2";
    ColorPalette["blue-3"] = "blue-3";
    ColorPalette["blue-4"] = "blue-4";
    ColorPalette["blue-5"] = "blue-5";
    ColorPalette["blue-6"] = "blue-6";
    ColorPalette["blue-7"] = "blue-7";
    ColorPalette["blue-8"] = "blue-8";
    ColorPalette["blue-9"] = "blue-9";
    ColorPalette["blue-10"] = "blue-10";
    ColorPalette["warmyellow"] = "warmyellow";
    ColorPalette["warmyellow-1"] = "warmyellow-1";
    ColorPalette["warmyellow-2"] = "warmyellow-2";
    ColorPalette["warmyellow-3"] = "warmyellow-3";
    ColorPalette["warmyellow-4"] = "warmyellow-4";
    ColorPalette["warmyellow-5"] = "warmyellow-5";
    ColorPalette["warmyellow-6"] = "warmyellow-6";
    ColorPalette["warmyellow-7"] = "warmyellow-7";
    ColorPalette["warmyellow-8"] = "warmyellow-8";
    ColorPalette["warmyellow-9"] = "warmyellow-9";
    ColorPalette["warmyellow-10"] = "warmyellow-10";
    ColorPalette["yellow"] = "yellow";
    ColorPalette["yellow-1"] = "yellow-1";
    ColorPalette["yellow-2"] = "yellow-2";
    ColorPalette["yellow-3"] = "yellow-3";
    ColorPalette["yellow-4"] = "yellow-4";
    ColorPalette["yellow-5"] = "yellow-5";
    ColorPalette["yellow-6"] = "yellow-6";
    ColorPalette["yellow-7"] = "yellow-7";
    ColorPalette["yellow-8"] = "yellow-8";
    ColorPalette["yellow-9"] = "yellow-9";
    ColorPalette["yellow-10"] = "yellow-10";
    ColorPalette["limegreen"] = "limegreen";
    ColorPalette["limegreen-1"] = "limegreen-1";
    ColorPalette["limegreen-2"] = "limegreen-2";
    ColorPalette["limegreen-3"] = "limegreen-3";
    ColorPalette["limegreen-4"] = "limegreen-4";
    ColorPalette["limegreen-5"] = "limegreen-5";
    ColorPalette["limegreen-6"] = "limegreen-6";
    ColorPalette["limegreen-7"] = "limegreen-7";
    ColorPalette["limegreen-8"] = "limegreen-8";
    ColorPalette["limegreen-9"] = "limegreen-9";
    ColorPalette["limegreen-10"] = "limegreen-10";
    ColorPalette["red"] = "red";
    ColorPalette["red-1"] = "red-1";
    ColorPalette["red-2"] = "red-2";
    ColorPalette["red-3"] = "red-3";
    ColorPalette["red-4"] = "red-4";
    ColorPalette["red-5"] = "red-5";
    ColorPalette["red-6"] = "red-6";
    ColorPalette["red-7"] = "red-7";
    ColorPalette["red-8"] = "red-8";
    ColorPalette["red-9"] = "red-9";
    ColorPalette["red-10"] = "red-10";
    ColorPalette["darkorange"] = "darkorange";
    ColorPalette["darkorange-1"] = "darkorange-1";
    ColorPalette["darkorange-2"] = "darkorange-2";
    ColorPalette["darkorange-3"] = "darkorange-3";
    ColorPalette["darkorange-4"] = "darkorange-4";
    ColorPalette["darkorange-5"] = "darkorange-5";
    ColorPalette["darkorange-6"] = "darkorange-6";
    ColorPalette["darkorange-7"] = "darkorange-7";
    ColorPalette["darkorange-8"] = "darkorange-8";
    ColorPalette["darkorange-9"] = "darkorange-9";
    ColorPalette["darkorange-10"] = "darkorange-10";
    ColorPalette["orange"] = "orange";
    ColorPalette["orange-1"] = "orange-1";
    ColorPalette["orange-2"] = "orange-2";
    ColorPalette["orange-3"] = "orange-3";
    ColorPalette["orange-4"] = "orange-4";
    ColorPalette["orange-5"] = "orange-5";
    ColorPalette["orange-6"] = "orange-6";
    ColorPalette["orange-7"] = "orange-7";
    ColorPalette["orange-8"] = "orange-8";
    ColorPalette["orange-9"] = "orange-9";
    ColorPalette["orange-10"] = "orange-10";
    ColorPalette["green"] = "green";
    ColorPalette["green-1"] = "green-1";
    ColorPalette["green-2"] = "green-2";
    ColorPalette["green-3"] = "green-3";
    ColorPalette["green-4"] = "green-4";
    ColorPalette["green-5"] = "green-5";
    ColorPalette["green-6"] = "green-6";
    ColorPalette["green-7"] = "green-7";
    ColorPalette["green-8"] = "green-8";
    ColorPalette["green-9"] = "green-9";
    ColorPalette["green-10"] = "green-10";
    ColorPalette["turquosie"] = "turquosie";
    ColorPalette["turquosie-1"] = "turquosie-1";
    ColorPalette["turquosie-2"] = "turquosie-2";
    ColorPalette["turquosie-3"] = "turquosie-3";
    ColorPalette["turquosie-4"] = "turquosie-4";
    ColorPalette["turquosie-5"] = "turquosie-5";
    ColorPalette["turquosie-6"] = "turquosie-6";
    ColorPalette["turquosie-7"] = "turquosie-7";
    ColorPalette["turquosie-8"] = "turquosie-8";
    ColorPalette["turquosie-9"] = "turquosie-9";
    ColorPalette["turquosie-10"] = "turquosie-10";
    ColorPalette["cobaltblue"] = "cobaltblue";
    ColorPalette["cobaltblue-1"] = "cobaltblue-1";
    ColorPalette["cobaltblue-2"] = "cobaltblue-2";
    ColorPalette["cobaltblue-3"] = "cobaltblue-3";
    ColorPalette["cobaltblue-4"] = "cobaltblue-4";
    ColorPalette["cobaltblue-5"] = "cobaltblue-5";
    ColorPalette["cobaltblue-6"] = "cobaltblue-6";
    ColorPalette["cobaltblue-7"] = "cobaltblue-7";
    ColorPalette["cobaltblue-8"] = "cobaltblue-8";
    ColorPalette["cobaltblue-9"] = "cobaltblue-9";
    ColorPalette["cobaltblue-10"] = "cobaltblue-10";
    ColorPalette["magenta"] = "magenta";
    ColorPalette["magenta-1"] = "magenta-1";
    ColorPalette["magenta-2"] = "magenta-2";
    ColorPalette["magenta-3"] = "magenta-3";
    ColorPalette["magenta-4"] = "magenta-4";
    ColorPalette["magenta-5"] = "magenta-5";
    ColorPalette["magenta-6"] = "magenta-6";
    ColorPalette["magenta-7"] = "magenta-7";
    ColorPalette["magenta-8"] = "magenta-8";
    ColorPalette["magenta-9"] = "magenta-9";
    ColorPalette["magenta-10"] = "magenta-10";
    ColorPalette["purple"] = "purple";
    ColorPalette["purple-1"] = "purple-1";
    ColorPalette["purple-2"] = "purple-2";
    ColorPalette["purple-3"] = "purple-3";
    ColorPalette["purple-4"] = "purple-4";
    ColorPalette["purple-5"] = "purple-5";
    ColorPalette["purple-6"] = "purple-6";
    ColorPalette["purple-7"] = "purple-7";
    ColorPalette["purple-8"] = "purple-8";
    ColorPalette["purple-9"] = "purple-9";
    ColorPalette["purple-10"] = "purple-10";
    ColorPalette["bc-red"] = "bc-red";
    ColorPalette["bc-red-1"] = "bc-red-1";
    ColorPalette["bc-red-2"] = "bc-red-2";
    ColorPalette["bc-red-3"] = "bc-red-3";
    ColorPalette["bc-red-4"] = "bc-red-4";
    ColorPalette["bc-red-5"] = "bc-red-5";
    ColorPalette["bc-red-6"] = "bc-red-6";
    ColorPalette["bc-red-7"] = "bc-red-7";
    ColorPalette["bc-red-8"] = "bc-red-8";
    ColorPalette["bc-red-9"] = "bc-red-9";
    ColorPalette["bc-blue"] = "bc-blue";
    ColorPalette["bc-blue-1"] = "bc-blue-1";
    ColorPalette["bc-blue-2"] = "bc-blue-2";
    ColorPalette["bc-blue-3"] = "bc-blue-3";
    ColorPalette["bc-blue-4"] = "bc-blue-4";
    ColorPalette["bc-blue-5"] = "bc-blue-5";
    ColorPalette["bc-blue-6"] = "bc-blue-6";
    ColorPalette["bc-blue-7"] = "bc-blue-7";
    ColorPalette["bc-blue-8"] = "bc-blue-8";
    ColorPalette["bc-blue-9"] = "bc-blue-9";
    ColorPalette["bc-green"] = "bc-green";
    ColorPalette["bc-green-1"] = "bc-green-1";
    ColorPalette["bc-green-2"] = "bc-green-2";
    ColorPalette["bc-green-3"] = "bc-green-3";
    ColorPalette["bc-green-4"] = "bc-green-4";
    ColorPalette["bc-green-5"] = "bc-green-5";
    ColorPalette["bc-green-6"] = "bc-green-6";
    ColorPalette["bc-green-7"] = "bc-green-7";
    ColorPalette["bc-green-8"] = "bc-green-8";
    ColorPalette["bc-green-9"] = "bc-green-9";
    ColorPalette["bc-orange"] = "bc-orange";
    ColorPalette["bc-orange-1"] = "bc-orange-1";
    ColorPalette["bc-orange-2"] = "bc-orange-2";
    ColorPalette["bc-orange-3"] = "bc-orange-3";
    ColorPalette["bc-orange-4"] = "bc-orange-4";
    ColorPalette["bc-orange-5"] = "bc-orange-5";
    ColorPalette["bc-orange-6"] = "bc-orange-6";
    ColorPalette["bc-orange-7"] = "bc-orange-7";
    ColorPalette["bc-orange-8"] = "bc-orange-8";
    ColorPalette["bc-orange-9"] = "bc-orange-9";
  })(Bcm.ColorPalette || (Bcm.ColorPalette = {}));
  (function (InputType) {
    InputType["text"] = "text";
    InputType["number"] = "number";
    InputType["email"] = "email";
    InputType["password"] = "password";
    InputType["url"] = "url";
    InputType["search"] = "search";
    InputType["tel"] = "tel";
    InputType["hidden"] = "hidden";
    InputType["color"] = "color";
  })(Bcm.InputType || (Bcm.InputType = {}));
  (function (KeyCode) {
    KeyCode[KeyCode["backspace"] = 8] = "backspace";
    KeyCode[KeyCode["tab"] = 9] = "tab";
    KeyCode[KeyCode["enter"] = 13] = "enter";
    KeyCode[KeyCode["shift"] = 16] = "shift";
    KeyCode[KeyCode["ctrl"] = 17] = "ctrl";
    KeyCode[KeyCode["alt"] = 18] = "alt";
    KeyCode[KeyCode["pause"] = 19] = "pause";
    KeyCode[KeyCode["capslock"] = 20] = "capslock";
    KeyCode[KeyCode["escape"] = 27] = "escape";
    KeyCode[KeyCode["space"] = 32] = "space";
    KeyCode[KeyCode["pageup"] = 33] = "pageup";
    KeyCode[KeyCode["pagedown"] = 34] = "pagedown";
    KeyCode[KeyCode["end"] = 35] = "end";
    KeyCode[KeyCode["home"] = 36] = "home";
    KeyCode[KeyCode["left"] = 37] = "left";
    KeyCode[KeyCode["up"] = 38] = "up";
    KeyCode[KeyCode["right"] = 39] = "right";
    KeyCode[KeyCode["down"] = 40] = "down";
    KeyCode[KeyCode["insert"] = 45] = "insert";
    KeyCode[KeyCode["delete"] = 46] = "delete";
    KeyCode[KeyCode["f1"] = 112] = "f1";
    KeyCode[KeyCode["f2"] = 113] = "f2";
    KeyCode[KeyCode["f3"] = 114] = "f3";
    KeyCode[KeyCode["f4"] = 115] = "f4";
    KeyCode[KeyCode["f5"] = 116] = "f5";
    KeyCode[KeyCode["f6"] = 117] = "f6";
    KeyCode[KeyCode["f7"] = 118] = "f7";
    KeyCode[KeyCode["f8"] = 119] = "f8";
    KeyCode[KeyCode["f9"] = 120] = "f9";
    KeyCode[KeyCode["f10"] = 121] = "f10";
    KeyCode[KeyCode["f11"] = 122] = "f11";
    KeyCode[KeyCode["f12"] = 123] = "f12";
    KeyCode[KeyCode["numlock"] = 144] = "numlock";
    KeyCode[KeyCode["scrolllock"] = 145] = "scrolllock";
    KeyCode[KeyCode["semicolon"] = 186] = "semicolon";
    KeyCode[KeyCode["equal"] = 187] = "equal";
    KeyCode[KeyCode["comma"] = 188] = "comma";
    KeyCode[KeyCode["dash"] = 189] = "dash";
    KeyCode[KeyCode["period"] = 190] = "period";
    KeyCode[KeyCode["slash"] = 191] = "slash";
    KeyCode[KeyCode["backslash"] = 220] = "backslash";
    KeyCode[KeyCode["bracketleft"] = 219] = "bracketleft";
    KeyCode[KeyCode["bracketright"] = 221] = "bracketright";
    KeyCode[KeyCode["quote"] = 222] = "quote";
    KeyCode[KeyCode["backtick"] = 192] = "backtick";
    KeyCode[KeyCode["a"] = 65] = "a";
  })(Bcm.KeyCode || (Bcm.KeyCode = {}));
  Bcm.FormErrorMessages = {
    "email": "Please enter a valid email address",
    "password": "Please enter a valid password",
    "url": "Please enter a valid URL",
    "phone": "Please enter a valid phone number",
    "search": "Please enter a valid search term",
    "number": "Please enter a valid number",
    "text": "Please enter a valid text",
    "required": "This field is required",
    "minlength": "Must be at least {0} chars long",
    "maxlength": "Must be at most {0} chars long",
    "betweenlength": "Must be between {0} and {1} chars long",
    "min": "This field must be at least {0}",
    "max": "This field must be at most {0}",
    "between": "This field must be between {0} and {1}",
    "pattern": "Please use a valid format",
    "date": "Please enter a valid date",
    "time": "Please enter a valid time",
    "datetime": "Please enter a valid date and time",
    "datetime-local": "Please enter a valid date and time",
    "month": "Please enter a valid month",
    "week": "Please enter a valid week",
    "color": "Please enter a valid color",
    "file": "Please enter a valid file",
    "range": "Please enter a valid range",
    "radio": "Please select a valid option",
    "checkbox": "Please select a valid option",
    "select": "Please select a valid option",
    "multiple": "Please select a valid option",
  };
  (function (IndeterminateType) {
    IndeterminateType["uncheck"] = "uncheck";
    IndeterminateType["indeterminate"] = "indeterminate";
    IndeterminateType["determinate"] = "determinate";
  })(Bcm.IndeterminateType || (Bcm.IndeterminateType = {}));
  (function (Placement) {
    Placement["top"] = "top";
    Placement["top-start"] = "top-start";
    Placement["top-end"] = "top-end";
    Placement["bottom"] = "bottom";
    Placement["bottom-start"] = "bottom-start";
    Placement["bottom-end"] = "bottom-end";
    Placement["left"] = "left";
    Placement["left-start"] = "left-start";
    Placement["left-end"] = "left-end";
    Placement["right"] = "right";
    Placement["right-start"] = "right-start";
    Placement["right-end"] = "right-end";
  })(Bcm.Placement || (Bcm.Placement = {}));
  (function (Position) {
    Position["top"] = "top";
    Position["bottom"] = "bottom";
    Position["left"] = "left";
    Position["right"] = "right";
  })(Bcm.Position || (Bcm.Position = {}));
  (function (TriggerType) {
    TriggerType["hover"] = "hover";
    TriggerType["click"] = "click";
    TriggerType["focus"] = "focus";
    TriggerType["custom"] = "custom";
  })(Bcm.TriggerType || (Bcm.TriggerType = {}));
  (function (ListType) {
    ListType["listbox"] = "listbox";
    ListType["select"] = "select";
    ListType["autocomplete"] = "autocomplete";
  })(Bcm.ListType || (Bcm.ListType = {}));
})(Bcm || (Bcm = {}));
const Bcm$1 = Bcm;

export { Bcm as B, Bcm$1 as a };
