/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core/internal/client';
import { S as StringHelper } from './string-helper.js';

const SlotTemplate = ({ value, className, name }) => {
  return StringHelper.isNullOrEmpty(value) ? h("span", { class: className },
    h("slot", Object.assign({}, (name && { name: name })))) : h("span", { class: className, innerHTML: value });
};

export { SlotTemplate as S };
