/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const BcmTypography = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
  }
  render() {
    return (h(Host, { class: "bcm-ui-element bcm-ui-content-display" }, h("slot", null)));
  }
  get el() { return this; }
}, [4, "bcm-typography"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-typography"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-typography":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmTypography);
      }
      break;
  } });
}

export { BcmTypography as B, defineCustomElement as d };
