import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
import { ButtonTypes, IconPositionTypes, KindTypes, SizeTypes } from '../../../models/bcm-types';
import { VariantProp } from './types';
export declare class BcmButton implements ComponentInterface {
  el: HTMLButtonElement;
  _id: string;
  hidden: boolean;
  type: ButtonTypes;
  size: SizeTypes;
  disabled: boolean;
  kind: KindTypes;
  outline: boolean;
  icon: string;
  href: string;
  target: string;
  value: string;
  loading: boolean;
  variant: VariantProp;
  dataDismiss: boolean;
  fullWidth: boolean;
  iconPosition: IconPositionTypes;
  color: any;
  checked: boolean;
  bcmClick: EventEmitter;
  handleOnClick(e: MouseEvent): boolean;
  componentWillRender(): void;
  getStateData(): import("../../../models/states/atoms/bcm-atoms-state").BcmAtomsState.Button;
  isHaveChildNodes(): boolean;
  setColor(color?: any): {
    [x: string]: string;
  };
  render(): any;
}
