import { StatusTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmChipGroup implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  name: string;
  value: any;
  required: boolean;
  size: "small" | "medium" | "large";
  label: string;
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  captionError: string;
  change: EventEmitter;
  handleSelectItem(e: any): void;
  handleDismiss(e: any): void;
  handleSelect(e: any): void;
  showListComponent(id: any): void;
  getSlots(): NodeListOf<HTMLBcmChipElement>;
  setSelect(val?: any, noEvent?: boolean): void;
  setAttr(): void;
  componentWillLoad(): void | Promise<void>;
  componentDidRender(): void;
  render(): any;
}
