import { EventEmitter, ComponentInterface } from '../../../stencil-public-runtime';
import { StatusProp, TypeProp } from './types';
export declare class BcmAlert implements ComponentInterface {
  el: HTMLElement;
  hidden: boolean;
  _id: string;
  _title: any;
  description: any;
  status: StatusProp;
  type: TypeProp;
  dismissible: any;
  icon: boolean;
  bigIcon: boolean;
  fullWidth: boolean;
  alertdismissible: EventEmitter;
  componentWillRender(): Promise<void> | void;
  dismiss(e: any): void;
  getStateData(): import("../../../models/states/molecules/bcm-molecules-state").BcmMoleculesState.Alert;
  setData(): void;
  render(): any;
}
