import { PositionTypes } from '../../../models';
import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
export declare class BcmDrawer implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  _title: any;
  position: PositionTypes;
  fullWidth: boolean;
  bcmBeforeOpen: EventEmitter;
  bcmBeforeClose: EventEmitter;
  _open: boolean;
  _close: boolean;
  show(): Promise<void>;
  hide(): Promise<void>;
  _beforeOpen(event: any): void;
  _beforeClose(event: any): void;
  _openHandler(): void;
  keyboardNavigation(e: any): void;
  disconnectedCallback(): void;
  render(): any;
}
