import { SizeProp } from './types';
export declare class BcmErrorLayout {
  el: HTMLElement;
  size: SizeProp;
  hidden: boolean;
  items: Array<object> | string;
  itemsProp: Array<object>;
  connectedCallback(): void;
  disconnectedCallback(): void;
  componentWillLoad(): void;
  componentDidLoad(): void;
  componentWillRender(): void;
  componentDidRender(): void;
  componentWillUpdate(): void;
  componentDidUpdate(): void;
  /**
   * @desc
   * @param newValue
   * @returns {void}
   */
  parseItems(newValue: Array<object> | string): void;
  set(val: any): Promise<void>;
  clear(): Promise<void>;
  render(): any;
}
