import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
import { PlacementTypes } from '../../../models';
export declare class BcmMenu implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  size: 'small' | 'medium' | 'large';
  collapsible: boolean;
  collapse: boolean;
  mode: 'horizontal' | 'vertical' | 'inline';
  disabled: boolean;
  hidden: boolean;
  linkedComponent: string;
  height: string;
  maxHeight: string;
  minHeight: string;
  selectable: boolean;
  gap: string;
  dropdown: boolean;
  placement: PlacementTypes;
  activeItemId: any;
  activeItem: any;
  data: any;
  bcmClick: EventEmitter;
  bcmExpanded: EventEmitter;
  bcmMenuChange: EventEmitter;
  setActive(param: any): Promise<void>;
  getActive(): Promise<any>;
  handleSlotItems({ detail }: {
    detail: any;
  }): void;
  private handleClickItem;
  private getTooltip;
  render(): any;
}
