import { StatusProp } from './types';
export declare class BcmMessage {
  /**
   * Component Element
   */
  el: HTMLElement;
  /**
   * Component Properties
   */
  status?: StatusProp;
  fullWidth?: boolean;
  loading?: boolean;
  isShow: boolean;
  hidden: boolean;
  /**
   * @desc
   */
  getIcon(): any;
  /**
   * @desc Removes component itself
   */
  dismiss(): void;
  /**
   * @desc
   */
  hide(): Promise<void>;
  /**
   * @desc
   */
  show(): Promise<void>;
  render(): any;
}
