import { EventEmitter } from '../../../stencil-public-runtime';
import { TypeProp } from './types';
export declare class BcmNotification {
  /**
   * Component Element
   */
  el: HTMLElement;
  /**
   * Component Properties
   */
  _title: string;
  status?: TypeProp;
  confirmText: any;
  isShow: boolean;
  hidden: boolean;
  /**
   * Component Events
   */
  confirm: EventEmitter;
  /**
   * @desc
   * @returns {BcmOldIcon}
   */
  getIcon(): any;
  /**
   * @desc Removes component itself
   */
  dismiss(): void;
  /**
   * @desc Removes component itself
   */
  handleConfirm(): void;
  /**
   * @desc
   */
  hide(): Promise<void>;
  /**
   * @desc
   */
  show(): Promise<void>;
  render(): any;
}
