import { ComponentInterface } from "../../../stencil-public-runtime";
import { NumberFormatValues, NumericFormatProps } from "react-number-format";
type ExtendedNumericPropsType = NumericFormatProps & {
  mode: "strict" | "none";
  onValueChange?: (e: NumberFormatValues) => void;
};
export declare class BcmReactNumber implements ComponentInterface {
  el: HTMLElement;
  disabled: boolean;
  options: ExtendedNumericPropsType;
  private isRange;
  componentWillRender(): void | Promise<void>;
  componentDidLoad(): void;
  private init;
}
export {};
