import { EventEmitter } from '../../../stencil-public-runtime';
import { PlacementTypes, TrigglerTypes } from '../../../models/bcm-types';
export declare class BcmPopconfirm {
  el: HTMLElement;
  _id: string;
  message: string;
  status: 'warning' | 'error';
  cancelText: string;
  okeyText: string;
  placement: PlacementTypes;
  trigger: TrigglerTypes;
  open: boolean;
  hidden: boolean;
  onShow: EventEmitter;
  onHide: EventEmitter;
  onConfirm: EventEmitter;
  onCancel: EventEmitter;
  show(): Promise<void>;
  hide(): Promise<void>;
  createBox(): Promise<void>;
  getPopconfirmBox(): any;
  showBox(): void;
  hideBox(): void;
  listenTrigger(event: any): void;
  onBcmConfirm(e: any): void;
  onBcmCancel(e: any): void;
  render(): any;
}
