import { Popover } from "../../../helper";
import { PlacementTypes, TrigglerTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmPopover implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  message: string;
  content: string;
  placement: PlacementTypes;
  trigger: TrigglerTypes;
  open: boolean;
  color: string;
  openDelay: number;
  closeDelay: number;
  autoHide: boolean;
  targetId: string;
  bcmPopoverShow: EventEmitter;
  bcmPopoverHide: EventEmitter;
  popover: Popover;
  emitShow(): void;
  emitHide(): void;
  connectedCallback(): void;
  componentDidLoad(): void;
  componentDidRender(): void;
  disconnectedCallback(): void;
  show(): Promise<void>;
  hide(): Promise<void>;
  toggle(): Promise<void>;
  render(): any;
}
