import { ComponentInterface } from "../../../stencil-public-runtime";
export declare class BcmProgress implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  value: number;
  max: number;
  size: "small" | "medium";
  type: "line" | "line-rounded" | "circle";
  info: "value-max" | "value" | "percent" | "icon";
  error: boolean;
  hidden: boolean;
  fullWidth: boolean;
  color: string;
  isCompleted: boolean;
  connectedCallback(): void;
  componentDidRender(): void;
  componentShouldUpdate(newVal: any, oldVal: any, propName: string): boolean | void;
  maxPercent(newValue: any): void;
  increment(percent: number): Promise<void>;
  decrement(percent: number): Promise<void>;
  set(percent: number): Promise<void>;
  handlePercent(percent: any, process?: "increment" | "decrement" | "set"): void;
  getIcon(type?: "circle" | "line"): any;
  render(): any;
}
