import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
import { DirectionTypes } from '../../../models/bcm-types';
export declare class BcmRange implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  min: number;
  max: number;
  step: number;
  value: any;
  height: string;
  name: string;
  direction: DirectionTypes;
  _prefix: string;
  _suffix: string;
  multiple: boolean;
  leftValue: number;
  rightValue: number;
  leftMin: number;
  change: EventEmitter;
  connectedCallback(): void;
  componentDidLoad(): void;
  setValue(value: any): Promise<any>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  getValue(): Promise<any>;
  syncValues(type: any, event: any): void;
  handleChange(): void;
  setThumbPosition(type: string): void;
  hiddenLeftThumb(): void;
  getTooltip(type: any): any;
  getThumb(type: string): any;
  getInput(type: string): any;
  touchToMove(value: any): void;
  hoverTick(id: any, status: any): void;
  render(): any;
}
