export declare class BcmTimeline {
  /**
   * Component Element
   */
  el: HTMLElement;
  /**
   * Component Properties
   */
  icon: string;
  type: 'left' | 'right' | 'alternate';
  hidden: boolean;
  /**
   * Component States
   */
  items: HTMLElement[];
  /**
   * @StencilMethod
   */
  componentDidRender(): void;
  /**
  * @StencilMethod
  */
  componentWillRender(): void;
  render(): any;
}
