export interface IDate {
  day: number;
  date: Date;
  thisMonth?: boolean;
  prevMonth?: boolean;
  nextMonth?: boolean;
  isWeekend?: boolean;
  today?: boolean;
}
export interface ICurrentDate {
  day: number;
  month: number;
  year: number;
  dayOfWeek: number;
  monthFirstDay: number;
  hour: number;
  minute: number;
}
export declare enum Months {
  january = "january",
  february = "february",
  march = "march",
  april = "april",
  may = "may",
  june = "june",
  july = "july",
  august = "august",
  september = "september",
  october = "october",
  november = "november",
  december = "december"
}
export declare enum Days {
  sunday = "sunday",
  monday = "monday",
  tuesday = "tuesday",
  wednesday = "wednesday",
  thursday = "thursday",
  friday = "friday",
  saturday = "saturday"
}
/**
 * 'type' prop predefined values
 */
export declare enum Types {
  datetime = "datetime",
  range = "range",
  date = "date",
  time = "time"
}
/**
 * 'type' prop types
 */
export declare type Type = keyof typeof Types;
