import { KeyControl } from "../../../models/abstract-classes/abstract-key-control";
export declare class ListKeyControl extends KeyControl {
  openGroup: (id: number) => void;
  checkedItem: (id: number) => void;
  private isTreeview;
  private isCheckBoxes;
  constructor(keyCode: number, element: HTMLElement, treeview: boolean, checkBoxes: boolean);
  private keyUpControl;
  private keyDownTreeView;
  private keyUpTreeview;
  private keyDownControl;
  private keyRightControl;
  private keyLeftControl;
  private keyEnterControl;
  private keySpaceControl;
  keyDown?(): void;
  keyUp?(): void;
}
