import { Bcm, SizeTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmAttendanceActions implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  size: SizeTypes;
  disabled: boolean;
  data: Bcm.InputDropdownData[];
  lateKeys: string;
  hideComment: boolean;
  change: EventEmitter;
  private get selectedItem();
  private get priorityButtons();
  private get renderButtons();
  private get lateKeysMap();
  private get isLate();
  private get dropdownMenuElement();
  private get commentAreaElement();
  private handleSelectItem;
  private changed;
  private hasDataForKey;
  private handleKeyPress;
  private handleSave;
  private dropdownMenu;
  private commentArea;
  set(key: string, triggerChange?: boolean): Promise<void>;
  get(): Promise<Bcm.InputDropdownData>;
  render(): any;
}
