import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
import { PlacementTypes } from "../../../models/bcm-types";
export declare class BcmToast implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  status: "success" | "error" | "warning" | "info";
  message: string;
  description: string;
  duration: number;
  position: PlacementTypes;
  messageIcon: any;
  viewButton: boolean;
  closeButton: boolean;
  removeAfterClose: boolean;
  bcmToastClose: EventEmitter;
  bcmToastOpen: EventEmitter;
  bcmToastView: EventEmitter;
  visible: boolean;
  visibleContainer: boolean;
  private timer;
  show(): Promise<HTMLElement>;
  hide(): Promise<void>;
  private handleMouseEnter;
  private handleMouseLeave;
  createContainer(position: PlacementTypes): HTMLElement;
  render(): any;
}
