import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
import { PlacementTypes, TrigglerTypes } from '../../../models/bcm-types';
export declare class OldBcmPopover implements ComponentInterface {
  el: HTMLElement;
  _title: string;
  _id: string;
  message: string;
  placement: PlacementTypes;
  trigger: TrigglerTypes;
  open: boolean;
  linkedComponent: string;
  onShow: EventEmitter;
  onHide: EventEmitter;
  show(): Promise<void>;
  hide(): Promise<void>;
  createBox(): void;
  getPopoverBox(): any;
  showBox(): void;
  hideBox(): void;
  listenTrigger(event: any): void;
  render(): any;
}
