import { EventEmitter } from '../../../stencil-public-runtime';
import { TypeProp } from './types';
export declare class BcmTab {
  /**
   * Component Element
   */
  el: HTMLElement;
  /**
   * Component Properties
   */
  type: TypeProp;
  active: boolean;
  disabled?: boolean;
  closable?: boolean;
  tabId?: string;
  formControl: string;
  hidden: boolean;
  status: 'processing' | 'error' | 'warning' | 'success' | 'default';
  badge: boolean;
  blink: boolean;
  /**
   * Component Events
   */
  click: EventEmitter;
  close: EventEmitter;
  /**
   * @desc
   */
  handleClose(): void;
  /**
   * @desc
   * @param event
   */
  handleClick(event: MouseEvent): void;
  render(): any;
}
