/**
 * 'size' prop predefined values
 */
export declare enum SizeProps {
  large = "large",
  medium = "medium",
  small = "small"
}
/**
 * 'type' prop predefined values
 */
export declare enum TypeProps {
  normal = "normal",
  pane = "pane",
  stepper = "stepper"
}
/**
 * 'direction' prop predefined values
 */
export declare enum DirectionProps {
  horizontal = "horizontal",
  vertical = "vertical"
}
/**
 * 'type' prop types
 */
export declare type TypeProp = keyof typeof TypeProps;
/**
 * 'size' prop types
 */
export declare type SizeProp = keyof typeof SizeProps;
/**
 * 'direction' prop types
 */
export declare type DirectionProp = keyof typeof DirectionProps;
/**
 * 'buttonState' prop types
 */
export declare type buttonStateProp = 'disabled' | 'hidden';
