import { SizeTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
import type { Moment } from "moment";
export declare class BcmRcPicker implements ComponentInterface {
  el: HTMLElement;
  placeholder: string;
  size: SizeTypes;
  error: boolean;
  disabled: boolean;
  clearable: boolean;
  ariaLabel: string;
  type: "time" | "date" | "week" | "month" | "year" | "datetime";
  format: any;
  range: boolean;
  showToday: boolean;
  disabledDates: {
    min: any;
    max: any;
    dates: any;
    custom: any;
  };
  showTime: boolean;
  showNow: boolean;
  showHour: boolean;
  showMinute: boolean;
  showSecond: boolean;
  use12Hours: boolean;
  hourStep: number;
  minuteStep: number;
  secondStep: number;
  hideDisabledOptions: boolean;
  disabledTime: {
    disabledHours: any;
    disabledMinutes: any;
    disabledSeconds: any;
  };
  bcmRCPickerChange: EventEmitter;
  newValue: any;
  set(value: Moment | null): Promise<void>;
  manageDisabledDates: (current: Moment) => any;
  manageDisabledTime: () => {
    disabledSeconds: () => any;
    disabledMinutes: () => any;
    disabledHours: () => any;
  };
  convertDateToMoment: (date: any) => Moment;
  componentDidRender(): void;
}
