import { GridOptions } from "@ag-grid-community/core";
import { Bcm } from "../../../models";
import { ComponentInterface } from "../../../stencil-public-runtime";
export declare class BcmTable implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  gridOptions: GridOptions;
  extensions: string;
  height: string;
  showToolbar: boolean;
  showFooter: boolean;
  toolBarConfig: Bcm.ToolBarButtonProps;
  agGrid: any;
  columns: any;
  fileTypes: any[];
  isReady: boolean;
  footerOptions: {
    statusBar: {
      statusPanels: ({
        statusPanel: string;
        align: string;
      } | {
        statusPanel: string;
        align?: undefined;
      })[];
    };
  };
  private get grid();
  componentDidLoad(): void;
  private initGrid;
  private initToolbar;
  private handleColumnVisible;
  private handleFileType;
  private handleSearch;
  watchHandler(newValue: GridOptions, oldValue: GridOptions): void;
  render(): any;
}
