import { Bcm } from "../models";
export declare class Generate {
  static UID: (prefix?: string) => string;
  static getIconAttrWithStatusType: (status: any, loading?: boolean) => {
    icon: string;
  };
  static prettify<T>(input: T): Bcm.Prettify<T>;
  static domParser: (html: string) => string;
  static createComponent: (el: any, props: any) => HTMLElement;
  static createElement: (tag: string, props: any) => HTMLElement;
  static debounceInput: (func: any, wait: any, immediate: any, callBack?: any) => () => void;
  static flatArray: (arr: any) => any;
  static reverseNodeList: (node_list: any) => any[];
  static findEventPathWithKey: (event: any, key: any, items: any) => boolean;
  static findEventPathHasAttribute: (event: any, key: any) => boolean;
  static findEventTarget: (event: any, items: any) => any;
  static findEventPathWithNodeName: (event: any, nodeName: any) => any;
  static findEventPath: (event: any, items: any) => boolean;
  static objectIsEmpty: (obj: any) => boolean;
  static convertIdsToNestedData: (ids: any, checklist: any) => any[];
  static nodeListToArray: (nodeList: any) => any;
  static setAttributes: (item: any, obj: any) => void;
  static computedStyle: (element: HTMLElement, property: string) => string;
  static getAncestor: (el: any, selector: any) => any;
  static findParentElement: (element: any, selector: any) => any;
  /**
      const dc = Generate.getTwColor({
          color: "blue",
          tones: {
              200: ["text"],
              700: ["bg", "border"],
              800: ["bg-hover", "border-hover"],
          },
          variable: "--bcm-avatar",
      });

      return {
          --bcm-avatar-text: --tw-blue-200;
          --bcm-avatar-bg: --tw-blue-700;
          --bcm-avatar-bg-hover: --tw-blue-800;
          --bcm-avatar-border: --tw-blue-700;
          --bcm-avatar-border-hover: --tw-blue-800;
      }
      
   */
  static getTwColor(args: any): {};
}
