export declare class StringHelper {
  static lowercase: (str: string) => string;
  static uppercase: (str: string) => string;
  static capitalize: (str: string) => string;
  static camelCase: (str: string) => string;
  static kebabCase: (str: string) => string;
  static snakeCase: (str: string) => string;
  static titleCase: (str: string) => string;
  static trim: (str: string) => string;
  static trimLeft: (str: string) => string;
  static trimRight: (str: string) => string;
  static trimAll: (str: string) => string;
  static replace: (str: string, search: string, replace: string) => string;
  static remove: (str: string, search: string) => string;
  static isNullOrEmpty: (str: string) => boolean;
  static localizationMessage: (str: any, args: any) => any;
  static getMessage: (type: string, args?: any[]) => any;
  static split: (str: string, separator: string) => string[];
  static textContains: (str: string, search: string) => boolean;
  static textLimitter: (str: string, limit: number, newLine?: boolean) => string;
  static slugify: (str: string) => string;
  static highlight: (str: string, search: string) => string;
  static templateParser: (str: string, data: any) => string;
  static parseStringToBoolean: (str: string) => boolean;
  static elementBooleanCheck: (obj: any) => boolean;
  static htmlEntities: (str: string) => string;
}
