export declare namespace BcmAtomsState {
  interface BaseAtoms {
    id: string | number;
  }
  interface Button extends BaseAtoms {
    type: any;
    hidden: any;
    size: any;
    disabled: any;
    outline: any;
    icon: any;
    href: any;
    kind: any;
    target: any;
    value: string;
    loading: boolean;
    variant: any;
    fullWidth: boolean;
    iconPosition: any;
    variantColor: string;
    isIconOnly: boolean;
    iconSize: any;
    dataDismiss: () => void;
  }
  interface Badge extends BaseAtoms {
    blink?: any;
    value?: any;
    _slot?: any;
    color?: any;
    size?: any;
    status?: any;
  }
}
export default BcmAtomsState;
