import { FunctionalComponent } from "../stencil-public-runtime";
import Bcm from "../models/bcm";
interface InputTemplateProps extends Bcm.InputClickEvent {
  elementType?: "textarea" | "input";
  rows?: any;
  id?: any;
  internalId?: any;
  type?: any;
  placeholder?: any;
  value?: any;
  size?: any;
  pattern?: any;
  unit?: any;
  unitPrefix?: any;
  maxLength?: any;
  disabled?: any;
  clearable?: any;
  focused?: any;
  readonly?: any;
  isPasswordVisible?: any;
  passwordToggle?: any;
  noDefaultIcon?: any;
  inValid?: any;
  captionType?: any;
  resize?: any;
  autocomplete?: any;
  _suffix?: any;
  _prefix?: any;
  changePasswordVisibility?: () => void;
  handleClear?: (e: MouseEvent) => void;
  steps?: (type: any) => void;
  isEyeDropperSupported?: () => boolean;
  eyeDropper?: () => void;
}
export declare const InputTemplate: FunctionalComponent<InputTemplateProps>;
export {};
