import { FunctionalComponent } from '../stencil-public-runtime';
import Bcm from '../models/bcm';
import { FontSizesTypes } from '../models/bcm-types';
interface TagTemplateProps {
  _id?: string;
  hostClasses?: string;
  classes?: string;
  color?: any;
  itemObject?: any;
  customStyle?: any;
  value?: string;
  type?: Bcm.TagType;
  hidden?: boolean;
  calculatedSize?: number;
  size?: FontSizesTypes | number;
  checked?: boolean;
  onDismiss?: (e?: any) => void;
  onSelect?: (e?: any) => void;
}
export declare const TagTemplate: FunctionalComponent<TagTemplateProps>;
export {};
