/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const index$1 = require('./index-95ae50d0.js');
const isLoadDecorator = require('./is-load-decorator-15036f37.js');
const generate = require('./generate-b43c3d3b.js');
const bcm = require('./bcm-1d1fcf21.js');
const captionTemplate = require('./caption-template-85a18b6d.js');
const input_style = require('./input.style-b5676e6a.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');
require('./index-5279dea2.js');

const inputCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.bcm-input[no-margin]{margin:0}.bcm-textarea[no-margin]{margin:0}.bcm-switch[no-margin]{margin:0}.bcm-checkbox[no-margin]{margin:0}.bcm-radio-group[no-margin]{margin:0}.bcm-checkbox-group[no-margin]{margin:0}.bcm-range[no-margin]{margin:0}.bcm-form[no-margin]{margin:0}.bcm-form-group[no-margin]{margin:0}.bcm-list[no-margin]{margin:0}.bcm-colorpicker[no-margin]{margin:0}.bcm-date-picker[no-margin]{margin:0}.bcm-time-picker[no-margin]{margin:0}.bcm-datetime-picker[no-margin]{margin:0}.bcm-select[no-margin]{margin:0}.bcm-listbox[no-margin]{margin:0}*{box-sizing:border-box}.bcm-input{display:inline-flex;flex-direction:column;width:100%;max-width:256px;margin-bottom:8px}.bcm-input.full-width{max-width:100%}.bcm-input.hidden{display:none}.bcm-input__container{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;display:flex;align-items:stretch;flex-direction:row;background-color:var(--bcm-new-ds-color-white);border:1px solid var(--bcm-new-ds-color-slate-300);border-radius:4px;box-sizing:border-box;cursor:text;padding:0 0 0 4px;position:relative;width:100%}.bcm-input__container.disabled{background-color:var(--bcm-new-ds-color-slate-50);cursor:not-allowed}.bcm-input__container.disabled .bcm-input-element{color:var(--bcm-new-ds-color-slate-500)}.bcm-input__container.readonly{background-color:var(--bcm-new-ds-color-slate-50);cursor:default}.bcm-input__container.readonly .bcm-input-element{color:var(--bcm-new-ds-color-slate-600)}.bcm-input__container:not(.disabled):hover .caret-container,.bcm-input__container:not(.disabled).focused .caret-container{opacity:1}.bcm-input__container:not(.disabled):hover .input-clear-button,.bcm-input__container:not(.disabled).focused .input-clear-button{opacity:1}.bcm-input__container:not(.disabled).focused{background-color:var(--bcm-new-ds-color-slate-50)}.bcm-input__container:not(.disabled):hover{border-color:var(--bcm-color-prime-blue-6)}.bcm-input__container.empty .input-clear-button{display:none}.bcm-input__container.invalid,.bcm-input__container.error{border-color:var(--bcm-new-ds-color-red-500)}.bcm-input__container .bcm-input-element{width:100%;color:var(--bcm-new-ds-color-slate-600);flex:1;border:none;background:transparent;box-shadow:unset;padding:0 4px;font-family:\"Inter\", sans-serif;cursor:inherit;-webkit-appearance:none;-moz-appearance:none;appearance:none;outline:none;text-overflow:ellipsis}.bcm-input__container .bcm-input-element::placeholder{font-family:\"Inter\", sans-serif;color:var(--bcm-new-ds-color-slate-300);user-select:none}.bcm-input__container .bcm-input-element::-webkit-search-decoration,.bcm-input__container .bcm-input-element::-webkit-search-cancel-button,.bcm-input__container .bcm-input-element::-webkit-search-results-button,.bcm-input__container .bcm-input-element::-webkit-search-results-decoration,.bcm-input__container .bcm-input-element::-webkit-calendar-picker-indicator,.bcm-input__container .bcm-input-element::-webkit-inner-spin-button,.bcm-input__container .bcm-input-element::-webkit-outer-spin-button{-webkit-appearance:none}.bcm-input__container .caret-container{width:30px;display:flex;flex-direction:column;justify-content:center;align-items:stretch;border-left:1px solid #D9D9D9;transition:0.2s opacity;user-select:none;box-sizing:border-box}.bcm-input__container .caret-container .bcm-input-caret{display:flex;align-items:center;justify-content:center;color:var(--bcm-color-grey-7);cursor:pointer;flex:1}.bcm-input__container .caret-container .bcm-input-caret bcm-icon{line-height:1}.bcm-input__container .caret-container .bcm-input-caret:hover{color:var(--bcm-color-prime-blue-6)}.bcm-input__container .caret-container .bcm-input-caret:active{background-color:var(--bcm-color-grey-3)}.bcm-input__container .caret-container .bcm-input-caret:last-child{border-top:1px solid #D9D9D9}.bcm-input__container .caret-container.disabled{background-color:var(--bcm-color-grey-3)}.bcm-input__container .caret-container.disabled .bcm-input-caret{cursor:not-allowed}.bcm-input__container .input-suffix-content{display:flex;align-items:center;justify-content:center}.bcm-input__container .input-prefix:not(:empty){padding-left:4px}.bcm-input__container .input-suffix:not(:empty){min-width:24px;padding-right:4px}.bcm-input__container .input-prefix:not(:empty),.bcm-input__container .input-suffix:not(:empty){display:flex;align-items:center;justify-content:center;cursor:default;color:#64748a}.bcm-input__container .input-prefix:not(:empty) .unit-prefix,.bcm-input__container .input-suffix:not(:empty) .unit-prefix{color:#64748a}.bcm-input__container .input-prefix-button:not(:empty),.bcm-input__container .input-suffix-button:not(:empty){cursor:pointer}.bcm-input__container .caret-container,.bcm-input__container .input-clear-button{opacity:0}.bcm-input__container--small{font-size:12px}.bcm-input__container--medium{font-size:14px}.bcm-input__container--large{font-size:16px}.bcm-input__textarea.clearable .bcm-input-element{padding-right:24px}.bcm-input__textarea .input-clear-button{position:absolute;top:4px;right:0}";

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmInput2 = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.focus = index.createEvent(this, "bcm-focus", 7);
    this.blur = index.createEvent(this, "bcm-blur", 7);
    this.clear = index.createEvent(this, "bcm-clear", 7);
    this.change = index.createEvent(this, "bcm-change", 7);
    this.input = index.createEvent(this, "bcm-input", 7);
    this._id = generate.Generate.UID();
    this._internal_id = generate.Generate.UID();
    this.value = "";
    this.size = bcm.Bcm$1.Size.medium;
    this.label = undefined;
    this.pattern = undefined;
    this.tooltip = undefined;
    this.placeholder = undefined;
    this.disabled = false;
    this.readonly = false;
    this.clearable = false;
    this.autocomplete = false;
    this.name = undefined;
    this.type = bcm.Bcm$1.InputType.text;
    this.hidden = false;
    this.required = false;
    this.fullWidth = false;
    this.noDefaultIcon = undefined;
    this.disableWatchValue = false;
    this.passwordToggle = false;
    this.maxLength = null;
    this.minLength = null;
    this.unitPrefix = null;
    this.unit = undefined;
    this.decimal = true;
    this.min = undefined;
    this.max = undefined;
    this.step = undefined;
    this.caption = undefined;
    this.noCaption = false;
    this.captionType = bcm.Bcm$1.Status.default;
    this.captionError = undefined;
    this.customErrorMessage = undefined;
    this._prefix = undefined;
    this._suffix = undefined;
    this.captionCache = undefined;
    this.captionTypeCache = undefined;
    this.inValid = false;
    this.valueCache = "";
    this.focused = false;
    this.isPasswordVisible = false;
  }
  async onBcmFocus() {
    this.inputElement.focus();
  }
  async onBcmBlur() {
    this.inputElement.blur();
  }
  async onBcmSelect() {
    this.inputElement.select();
  }
  handleClear(e) {
    this.inputElement.value = "";
    this.value = "";
    this.inputElement.focus();
    this.clear.emit(e);
    this.change.emit(this.value);
    e.stopPropagation();
  }
  handleInput(_e) {
    this.value = this.inputElement.value;
    this.input.emit(this.value);
    this.change.emit(this.value);
  }
  handleChange(_e) {
    this.value = this.inputElement.value;
    this.change.emit(this.value);
  }
  handleFocus(e) {
    this.focused = true;
    this.focus.emit(e);
  }
  handleBlur(e) {
    this.focused = false;
    this.blur.emit(e);
  }
  handleKeyUp(e) {
    if (e.key === "Enter") {
      this.blur.emit(e);
    }
  }
  render() {
    const { value, size, label, type, captionType, caption, captionError, placeholder, fullWidth, disabled, readonly, clearable, 
    // passwordToggle,
    // isPasswordVisible,
    // noDefaultIcon,
    unit, inValid, focused, 
    // unitPrefix,
    noCaption, required, hidden, _id, autocomplete, _prefix, _suffix, } = this;
    const isActiveClearable = (value === null || value === void 0 ? void 0 : value.length) > 0 && clearable;
    const { host, inputContainer, input, slotClass, clearButton, controls, controlsBtn, controlsBtnDown, controlsBtnUp, controlsDivider } = input_style.inputStyle({
      size,
      fullWidth,
      // şüpheli kısımlar
      focused: focused,
      clearable: isActiveClearable,
      disabled,
      readonly,
      invalid: inValid,
      unit: (unit === null || unit === void 0 ? void 0 : unit.length) > 0,
      // 'empty': value?.length < 1,
      error: captionType === "error",
      hidden,
    });
    return (index.h(index.Host, { class: host(), onClick: () => this.onBcmFocus() }, label && index.h("bcm-label", { tooltip: this.tooltip, type: captionType, value: label, required: required, htmlFor: _id }), index.h("div", { class: inputContainer() }, index.h("div", { class: slotClass() }, index.h("slot", { name: "prefix" }, _prefix && _prefix.length > 0 && index.h("span", { innerHTML: _prefix }))), index.h("input", { class: input(), id: _id, type: type, value: value, pattern: this.pattern, placeholder: placeholder, disabled: disabled, readonly: readonly, ref: el => (this.inputElement = el), onInput: event => this.handleInput(event), onChange: event => this.handleChange(event), onFocus: event => this.handleFocus(event), onBlur: event => this.handleBlur(event), onKeyUp: event => this.handleKeyUp(event), autoComplete: autocomplete ? "on" : "off", required: required }), index.h("div", { class: slotClass() }, isActiveClearable && (index.h("button", { type: "button", class: clearButton(), onClick: event => this.handleClear(event) }, index.h("i", { class: "far fa-times" }))), index.h("slot", { name: "suffix" }, _suffix && _suffix.length > 0 && index.h("span", { innerHTML: _suffix })), type === "number" && (index.h("div", { class: controls() }, index.h("button", { type: "button", onClick: () => this.onBcmFocus(), class: index$1.classnames(controlsBtn(), controlsBtnUp()) }, index.h("i", { class: "fas fa-caret-up" })), index.h("div", { class: controlsDivider() }), index.h("button", { type: "button", onClick: () => this.onBcmFocus(), class: index$1.classnames(controlsBtn(), controlsBtnDown()) }, index.h("i", { class: "fas fa-caret-down" })))))), index.h(captionTemplate.CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionError: captionError, caption: caption, customErrorMessage: this.customErrorMessage })));
  }
};
__decorate([
  isLoadDecorator.IsLoad()
], BcmInput2.prototype, "inputElement", void 0);
BcmInput2.style = inputCss;

exports.bcm_input_2 = BcmInput2;
