/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate } from "@bcm/helpers";
import { Host, h } from "@stencil/core";
import cs from "classnames";
export class BcmModal2Footer {
  constructor() {
    this._id = Generate.UID();
    this.el.slot = "footer";
  }
  render() {
    return (h(Host, { class: cs("tw-flex tw-flex-row tw-items-center tw-justify-end tw-gap-2 tw-px-6 tw-pb-6 tw-pt-2") }, h("slot", null)));
  }
  static get is() { return "bcm-modal-2-footer"; }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      }
    };
  }
  static get elementRef() { return "el"; }
}
