/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Host, h } from "@stencil/core";
import cs from "classnames";
export class BcmScrollArea {
  constructor() {
    this.width = "inherit";
    this.height = "inherit";
    this.isDisabled = false;
  }
  render() {
    return (h(Host, { class: cs("tw-block", {
        "tw-overflow-y-scroll tw-overscroll-contain": !this.isDisabled,
      }), style: { width: this.width, height: this.height } }, h("slot", null)));
  }
  static get is() { return "bcm-scroll-area"; }
  static get properties() {
    return {
      "width": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "width",
        "reflect": false,
        "defaultValue": "\"inherit\""
      },
      "height": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "height",
        "reflect": false,
        "defaultValue": "\"inherit\""
      },
      "isDisabled": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "is-disabled",
        "reflect": false,
        "defaultValue": "false"
      }
    };
  }
}
