/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate } from "@bcm/helpers";
const ExportTypes = {
  csv: {
    id: Generate.UID(),
    text: "Csv",
    icon: "blue-color far fa-file-csv",
    path: "csv.svg",
  },
  xls: {
    id: Generate.UID(),
    text: "Excel",
    icon: "green-color far fa-file-excel",
    path: "excel.svg",
  },
  pdf: {
    id: Generate.UID(),
    text: "Pdf",
    icon: "red-color far fa-file-pdf",
    path: "pdf.svg",
  },
};
const tableOptions = {
  overlayNoRowsTemplate: `
         <section class='tw-flex !tw-h-full'>
           <div class='tw-flex tw-flex-col tw-items-center tw-justify-center tw-gap-2 tw-mt-6'>
                <div class='tw-flex tw-items-center tw-justify-center tw-h-14 tw-w-14 tw-mt-6 tw-bg-amber-400 tw-rounded-full tw-text-white'>
                  <i class='fas fa-folder-open fa-2x'></i>
                </div>
                <bcm-text font-size='3'> No Data Available!</bcm-text>
           </div>
        </section>`,
  defaultColDef: {
    flex: 1,
  },
  // domLayout: "autoHeight",
  animateRows: true,
};
export { ExportTypes, tableOptions };
