/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import Bcm from '../models/bcm';
import { SlotTemplate } from './slot-template';
export const ButtonTemplate = ({ value, type, componentClass, disabled, href, target, loading, isIconOnly, icon, iconPosition, id }) => {
  const ButtonTagType = (href) ? Bcm.HtmlElementType.a : Bcm.HtmlElementType.button;
  return (h(ButtonTagType, Object.assign({ id: id }, (type == Bcm.HtmlElementType.button && { type }), { class: componentClass, disabled: disabled, href: href, target: target, tabindex: "0", "aria-label": "button" }), h("span", { hidden: true }, h("slot", null)), loading && h("span", { class: "bcm-button__container-loading" }, " ", h("span", { class: "bcm-button__container-icon" }, h("i", { class: "far fa-spinner-third fa-spin" }), " ")), icon && h("span", { class: `${iconPosition} bcm-button__container-icon` }, h("i", { class: `${icon}` })), !isIconOnly && (h(SlotTemplate, { className: "bcm-button__container-text", value: value })), h("slot", { name: "suffix" })));
};
