/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import { pluralize } from '../utils/utils';
export const InfoFooterTemplate = ({ selected, total, found, multiple, variableText }) => {
  total = total || 0;
  variableText = variableText ? pluralize(variableText, total) : 'items';
  return (h("footer", { class: "bcm-info-footer" }, h("bcm-text", { scale: "size-1", color: "grey-8" }, (multiple && selected > 0) && ` ( ${selected} selected ) `, ` Total ${total} `, found != null && ` / ${found} `, ` ${variableText} found. `)));
};
