/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import { StringHelper } from '../helper/string-helper';
export const SlotTemplate = ({ value, className, name }) => {
  return StringHelper.isNullOrEmpty(value) ? h("span", { class: className }, h("slot", Object.assign({}, (name && { name: name })))) : h("span", { class: className, innerHTML: value });
};
