/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
// /**
//  * 
//  * @param type 
//  */
// export const required = (value:any) => {
//   if ( value || value != null ) {
//     return true
//   } else {
//     return true
//   }
// }
export class rules {
  constructor() { }
  response(status, message) {
    return Object.assign(Object.assign({ valid: status }, (message && { message })), (!status && { type: 'error' }));
  }
  required(value, componentValidation) {
    let validation = this.response(true);
    if (value == '' || value == "" || value == undefined || value == null || value === false) {
      validation = this.response(false, 'This field is required');
    }
    if (componentValidation) {
      if (!componentValidation.valid) {
        validation = this.response(false, componentValidation.errorText);
      }
      if (value instanceof Object) {
        if (value.isValid) {
          if (value.isValid == false)
            validation = this.response(false, 'This field is required');
        }
      }
    }
    return validation;
  }
  selfValidation(input) {
    let validation = this.response(true);
    if (input.captionError != null || input.captionType == 'error') {
      validation = this.response(false, input.captionError);
    }
    return validation;
  }
}
export const validate = new rules;
