/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const BcmContent$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.el.slot = "content";
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
  get el() { return this; }
}, [4, "bcm-content"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-content"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-content":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmContent$1);
      }
      break;
  } });
}

const BcmContent = BcmContent$1;
const defineCustomElement = defineCustomElement$1;

export { BcmContent, defineCustomElement };
