/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const treeviewGroupCss = "";

const BcmtreeviewGroup = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h("slot", null));
  }
  static get style() { return treeviewGroupCss; }
}, [1, "bcm-treeview-group"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-treeview-group"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-treeview-group":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmtreeviewGroup);
      }
      break;
  } });
}

const BcmTreeviewGroup = BcmtreeviewGroup;
const defineCustomElement = defineCustomElement$1;

export { BcmTreeviewGroup, defineCustomElement };
