/* BromcomUi custom elements */
export { BcmAccordion as BcmAccordion } from '../types/components/molecules/accordion/accordion';
export { BcmAlert as BcmAlert } from '../types/components/molecules/alert/alert';
export { BcmAttendance as BcmAttendance } from '../types/components/other/attendance/attendance';
export { BcmAttendanceActions as BcmAttendanceActions } from '../types/components/other/attendance-actions/attendance-actions';
export { BcmAttendanceActionsComment as BcmAttendanceActionsComment } from '../types/components/other/attendance-actions/attendance-actions-comment';
export { BcmAttendanceActionsDropdown as BcmAttendanceActionsDropdown } from '../types/components/other/attendance-actions/attendance-actions-dropdown';
export { BcmAutocomplete as BcmAutocomplete } from '../types/components/organism/autocomplete/autocomplete';
export { BcmAvatar as BcmAvatar } from '../types/components/atoms/avatar/avatar';
export { BcmBadge as BcmBadge } from '../types/components/atoms/badge/badge';
export { BcmBox as BcmBox } from '../types/components/other/box/box';
export { BcmBreadcrumb as BcmBreadcrumb } from '../types/components/molecules/breadcrumb/breadcrumb';
export { BcmButton as BcmButton } from '../types/components/atoms/button/button';
export { BcmButtonGroup as BcmButtonGroup } from '../types/components/molecules/button-group/button-group';
export { BcmCaption as BcmCaption } from '../types/components/atoms/caption/caption';
export { BcmCard as BcmCard } from '../types/components/molecules/card/card';
export { BcmCheckbox as BcmCheckbox } from '../types/components/molecules/checkbox/checkbox';
export { BcmCheckboxGroup as BcmCheckboxGroup } from '../types/components/molecules/checkbox/group';
export { BcmCheckboxLite as BcmCheckboxLite } from '../types/components/molecules/checkbox/checkbox-lite';
export { BcmChip as BcmChip } from '../types/components/atoms/chip/chip';
export { BcmChipGroup as BcmChipGroup } from '../types/components/atoms/chip/chip-group';
export { BcmCollapse as BcmCollapse } from '../types/components/other_deprecated/collapse/collapse';
export { BcmCollapseGroup as BcmCollapseGroup } from '../types/components/other_deprecated/collapse/group';
export { BcmColorInput as BcmColorInput } from '../types/components/molecules/color-input/color-input';
export { BcmColorful as BcmColorful } from '../types/components/third-parts/colorful/colorful';
export { BcmColorPicker as BcmColorpicker } from '../types/components/other_deprecated/colorpicker/colorpicker';
export { BcmContent as BcmContent } from '../types/components/other/content/content';
export { BcmDate as BcmDate } from '../types/components/third-parts/rc-picker/date';
export { BcmDatePicker as BcmDatePicker } from '../types/components/organism/date-picker/date-picker';
export { BcmDatetimePicker as BcmDatetimePicker } from '../types/components/organism/datetime-picker/datetime-picker';
export { BcmDefault as BcmDefault } from '../types/components/other/default/default';
export { BcmDivider as BcmDivider } from '../types/components/atoms/divider/divider';
export { BcmDrawer as BcmDrawer } from '../types/components/molecules/drawer/drawer';
export { BcmDropdown as BcmDropdown } from '../types/components/molecules/dropdown/dropdown';
export { BcmEmpty as BcmEmpty } from '../types/components/molecules/empty/empty';
export { BcmErrorLayout as BcmErrorLayout } from '../types/components/molecules/error-layout/error-layout';
export { BcmExpansionPanel as BcmExpansionPanel } from '../types/components/molecules/expansion-panel/expansion-panel';
export { BcmForm as BcmForm } from '../types/components/organism/form/form';
export { BcmForm2 as BcmForm2 } from '../types/components/organism/form-2/form-2';
export { BcmFormGroup as BcmFormGroup } from '../types/components/organism/form/form-group';
export { BcmIcon as BcmIcon } from '../types/components/atoms/icon/icon';
export { BcmInput as BcmInput } from '../types/components/molecules/input/input';
export { BcmInput2 as BcmInput2 } from '../types/components/molecules/input/input2';
export { BcmInputCustom as BcmInputCustom } from '../types/components/other/input-custom/input-custom';
export { BcmInputDropdown as BcmInputDropdown } from '../types/components/molecules/input-dropdown/input-dropdown';
export { BcmItem as BcmItem } from '../types/components/molecules/item/item';
export { BcmItems as BcmItems } from '../types/components/molecules/items/items';
export { BcmLabel as BcmLabel } from '../types/components/atoms/label/label';
export { BcmLink as BcmLink } from '../types/components/atoms/link/link';
export { BcmLinked as BcmLinked } from '../types/components/molecules/linked/linked';
export { BcmList as BcmList } from '../types/components/organism/list/list';
export { BcmListbox as BcmListbox } from '../types/components/other_deprecated/listbox/listbox';
export { BcmListboxGroup as BcmListboxGroup } from '../types/components/other_deprecated/listbox/listbox-group';
export { BcmListboxItem as BcmListboxItem } from '../types/components/other_deprecated/listbox/listbox-item';
export { BcmMenu as BcmMenu } from '../types/components/molecules/menu/menu';
export { BcmMessage as BcmMessage } from '../types/components/molecules/message/message';
export { BcmModal as BcmModal } from '../types/components/molecules/modal/modal';
export { BcmModal2 as BcmModal2 } from '../types/components/other/modal-2/modal-2';
export { BcmModal2Footer as BcmModal2Footer } from '../types/components/other/modal-2/modal-2-footer';
export { BcmModal2Header as BcmModal2Header } from '../types/components/other/modal-2/modal-2-header';
export { BcmNotification as BcmNotification } from '../types/components/molecules/notification/notification';
export { NumberInput as BcmNumberInput } from '../types/components/molecules/number-input/number-input';
export { BcmOldInput as BcmOldInput } from '../types/components/other_deprecated/old-input/old-input';
export { BcmOldSearch as BcmOldSearch } from '../types/components/other_deprecated/old-search/old-search';
export { BcmOldTag as BcmOldTag } from '../types/components/other_deprecated/old-tag/old-tag';
export { BcmOverlay as BcmOverlay } from '../types/components/other/overlay/overlay';
export { BcmPopconfirm as BcmPopconfirm } from '../types/components/molecules/popconfirm/popconfirm';
export { BcmPopconfirmBox as BcmPopconfirmBox } from '../types/components/molecules/popconfirm/popconfirm-box';
export { BcmPopover as BcmPopover } from '../types/components/molecules/popover/popover';
export { BcmProgress as BcmProgress } from '../types/components/molecules/progress/progress';
export { BcmRadio as BcmRadio } from '../types/components/molecules/radio/radio';
export { BcmRadioGroup as BcmRadioGroup } from '../types/components/molecules/radio/radio-group';
export { BcmRange as BcmRange } from '../types/components/molecules/range/range';
export { BcmRcOverflow as BcmRcOverflow } from '../types/components/third-parts/rc-overflow/rc-overflow';
export { BcmRcPicker as BcmRcPicker } from '../types/components/third-parts/rc-picker/rc-picker';
export { BcmReactNumber as BcmReactNumber } from '../types/components/molecules/number-input/react-input';
export { BcmResult as BcmResult } from '../types/components/molecules/result/result';
export { BcmScrollArea as BcmScrollArea } from '../types/components/other/scroll-area/scroll-area';
export { BcmSearch as BcmSearch } from '../types/components/molecules/search/search';
export { BcmSelect as BcmSelect } from '../types/components/other_deprecated/select/select';
export { BcmSelectBox as BcmSelectBox } from '../types/components/other_deprecated/select/select-box';
export { BcmSelectGroup as BcmSelectGroup } from '../types/components/other_deprecated/select/group';
export { BcmSelectOption as BcmSelectOption } from '../types/components/other_deprecated/select/option';
export { BcmShortcut as BcmShortcut } from '../types/components/other/shortcut/shortcut';
export { BcmSkeleton as BcmSkeleton } from '../types/components/molecules/skeleton/skeleton';
export { BcmStep as BcmStep } from '../types/components/molecules/stepper/step';
export { BcmStepper as BcmStepper } from '../types/components/molecules/stepper/stepper';
export { BcmSwitch as BcmSwitch } from '../types/components/molecules/switch/switch';
export { BcmTab as BcmTab } from '../types/components/other_deprecated/tabs/tab';
export { BcmTabGroup as BcmTabGroup } from '../types/components/molecules/tab-group/tab-group';
export { BcmTabItem as BcmTabItem } from '../types/components/molecules/tab-group/tab-item';
export { BcmTabItemHeader as BcmTabItemHeader } from '../types/components/molecules/tab-group/tab-item-header';
export { BcmTabPane as BcmTabPane } from '../types/components/other_deprecated/tabs/tab-pane';
export { BcmTable as BcmTable } from '../types/components/third-parts/table/table';
export { BcmTabs as BcmTabs } from '../types/components/other_deprecated/tabs/tabs';
export { BcmTabsContent as BcmTabsContent } from '../types/components/other_deprecated/tabs/tabs-content';
export { BcmTag as BcmTag } from '../types/components/other_deprecated/tag/tag';
export { BcmText as BcmText } from '../types/components/other_deprecated/text/text';
export { BcmTextarea as BcmTextarea } from '../types/components/molecules/textarea/textarea';
export { BcmTimePicker as BcmTimePicker } from '../types/components/organism/time-picker/time-picker';
export { BcmTimeline as BcmTimeline } from '../types/components/molecules/timeline/timeline';
export { BcmTimelineItem as BcmTimelineItem } from '../types/components/molecules/timeline/timeline-item';
export { BcmToast as BcmToast } from '../types/components/other/toast/toast';
export { BcmTooltip as BcmTooltip } from '../types/components/molecules/tooltip/tooltip';
export { Bcmtreeview as BcmTreeview } from '../types/components/other_deprecated/treeview/treeview';
export { BcmtreeviewGroup as BcmTreeviewGroup } from '../types/components/other_deprecated/treeview/treeview-group';
export { BcmtreeviewItem as BcmTreeviewItem } from '../types/components/other_deprecated/treeview/treeview-item';
export { BcmTypography as BcmTypography } from '../types/components/other/typography/typography';
export { OldBcmPopover as OldBcmPopover } from '../types/components/other_deprecated/old-popover/old-popover';
export { OldBcmPopoverBox as OldBcmPopoverBox } from '../types/components/other_deprecated/old-popover/old-popover-box';

/**
 * Used to manually set the base path where assets can be found.
 * If the script is used as "module", it's recommended to use "import.meta.url",
 * such as "setAssetPath(import.meta.url)". Other options include
 * "setAssetPath(document.currentScript.src)", or using a bundler's replace plugin to
 * dynamically set the path at build time, such as "setAssetPath(process.env.ASSET_PATH)".
 * But do note that this configuration depends on how your script is bundled, or lack of
 * bundling, and where your assets can be loaded from. Additionally custom bundling
 * will have to ensure the static assets are copied to its build directory.
 */
export declare const setAssetPath: (path: string) => void;

/**
 * Used to specify a nonce value that corresponds with an application's CSP.
 * When set, the nonce will be added to all dynamically created script and style tags at runtime.
 * Alternatively, the nonce value can be set on a meta tag in the DOM head
 * (<meta name="csp-nonce" content="{ nonce value here }" />) which
 * will result in the same behavior.
 */
export declare const setNonce: (nonce: string) => void

export interface SetPlatformOptions {
  raf?: (c: FrameRequestCallback) => number;
  ael?: (el: EventTarget, eventName: string, listener: EventListenerOrEventListenerObject, options: boolean | AddEventListenerOptions) => void;
  rel?: (el: EventTarget, eventName: string, listener: EventListenerOrEventListenerObject, options: boolean | AddEventListenerOptions) => void;
}
export declare const setPlatformOptions: (opts: SetPlatformOptions) => void;
export * from '../types';
