/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Env } from '@stencil/core/internal/client';
export { setAssetPath, setNonce, setPlatformOptions } from '@stencil/core/internal/client';
import { v as version } from './generate.js';
import { L as LicenseManager } from './bcm-table.js';
export { BcmTable, defineCustomElement as defineCustomElementBcmTable } from './bcm-table.js';
export { BcmAccordion, defineCustomElement as defineCustomElementBcmAccordion } from './bcm-accordion.js';
export { BcmAlert, defineCustomElement as defineCustomElementBcmAlert } from './bcm-alert.js';
export { BcmAttendance, defineCustomElement as defineCustomElementBcmAttendance } from './bcm-attendance.js';
export { BcmAttendanceActions, defineCustomElement as defineCustomElementBcmAttendanceActions } from './bcm-attendance-actions.js';
export { BcmAttendanceActionsComment, defineCustomElement as defineCustomElementBcmAttendanceActionsComment } from './bcm-attendance-actions-comment.js';
export { BcmAttendanceActionsDropdown, defineCustomElement as defineCustomElementBcmAttendanceActionsDropdown } from './bcm-attendance-actions-dropdown.js';
export { BcmAutocomplete, defineCustomElement as defineCustomElementBcmAutocomplete } from './bcm-autocomplete.js';
export { BcmAvatar, defineCustomElement as defineCustomElementBcmAvatar } from './bcm-avatar.js';
export { BcmBadge, defineCustomElement as defineCustomElementBcmBadge } from './bcm-badge.js';
export { BcmBox, defineCustomElement as defineCustomElementBcmBox } from './bcm-box.js';
export { BcmBreadcrumb, defineCustomElement as defineCustomElementBcmBreadcrumb } from './bcm-breadcrumb.js';
export { BcmButton, defineCustomElement as defineCustomElementBcmButton } from './bcm-button.js';
export { BcmButtonGroup, defineCustomElement as defineCustomElementBcmButtonGroup } from './bcm-button-group.js';
export { BcmCaption, defineCustomElement as defineCustomElementBcmCaption } from './bcm-caption.js';
export { BcmCard, defineCustomElement as defineCustomElementBcmCard } from './bcm-card.js';
export { BcmCheckbox, defineCustomElement as defineCustomElementBcmCheckbox } from './bcm-checkbox.js';
export { BcmCheckboxGroup, defineCustomElement as defineCustomElementBcmCheckboxGroup } from './bcm-checkbox-group.js';
export { BcmCheckboxLite, defineCustomElement as defineCustomElementBcmCheckboxLite } from './bcm-checkbox-lite.js';
export { BcmChip, defineCustomElement as defineCustomElementBcmChip } from './bcm-chip.js';
export { BcmChipGroup, defineCustomElement as defineCustomElementBcmChipGroup } from './bcm-chip-group.js';
export { BcmCollapse, defineCustomElement as defineCustomElementBcmCollapse } from './bcm-collapse.js';
export { BcmCollapseGroup, defineCustomElement as defineCustomElementBcmCollapseGroup } from './bcm-collapse-group.js';
export { BcmColorInput, defineCustomElement as defineCustomElementBcmColorInput } from './bcm-color-input.js';
export { BcmColorful, defineCustomElement as defineCustomElementBcmColorful } from './bcm-colorful.js';
export { BcmColorpicker, defineCustomElement as defineCustomElementBcmColorpicker } from './bcm-colorpicker.js';
export { BcmContent, defineCustomElement as defineCustomElementBcmContent } from './bcm-content.js';
export { BcmDate, defineCustomElement as defineCustomElementBcmDate } from './bcm-date.js';
export { BcmDatePicker, defineCustomElement as defineCustomElementBcmDatePicker } from './bcm-date-picker.js';
export { BcmDatetimePicker, defineCustomElement as defineCustomElementBcmDatetimePicker } from './bcm-datetime-picker.js';
export { BcmDefault, defineCustomElement as defineCustomElementBcmDefault } from './bcm-default.js';
export { BcmDivider, defineCustomElement as defineCustomElementBcmDivider } from './bcm-divider.js';
export { BcmDrawer, defineCustomElement as defineCustomElementBcmDrawer } from './bcm-drawer.js';
export { BcmDropdown, defineCustomElement as defineCustomElementBcmDropdown } from './bcm-dropdown.js';
export { BcmEmpty, defineCustomElement as defineCustomElementBcmEmpty } from './bcm-empty.js';
export { BcmErrorLayout, defineCustomElement as defineCustomElementBcmErrorLayout } from './bcm-error-layout.js';
export { BcmExpansionPanel, defineCustomElement as defineCustomElementBcmExpansionPanel } from './bcm-expansion-panel.js';
export { BcmForm, defineCustomElement as defineCustomElementBcmForm } from './bcm-form.js';
export { BcmForm2, defineCustomElement as defineCustomElementBcmForm2 } from './bcm-form-2.js';
export { BcmFormGroup, defineCustomElement as defineCustomElementBcmFormGroup } from './bcm-form-group.js';
export { BcmIcon, defineCustomElement as defineCustomElementBcmIcon } from './bcm-icon.js';
export { BcmInput, defineCustomElement as defineCustomElementBcmInput } from './bcm-input.js';
export { BcmInput2, defineCustomElement as defineCustomElementBcmInput2 } from './bcm-input-2.js';
export { BcmInputCustom, defineCustomElement as defineCustomElementBcmInputCustom } from './bcm-input-custom.js';
export { BcmInputDropdown, defineCustomElement as defineCustomElementBcmInputDropdown } from './bcm-input-dropdown.js';
export { BcmItem, defineCustomElement as defineCustomElementBcmItem } from './bcm-item.js';
export { BcmItems, defineCustomElement as defineCustomElementBcmItems } from './bcm-items.js';
export { BcmLabel, defineCustomElement as defineCustomElementBcmLabel } from './bcm-label.js';
export { BcmLink, defineCustomElement as defineCustomElementBcmLink } from './bcm-link.js';
export { BcmLinked, defineCustomElement as defineCustomElementBcmLinked } from './bcm-linked.js';
export { BcmList, defineCustomElement as defineCustomElementBcmList } from './bcm-list.js';
export { BcmListbox, defineCustomElement as defineCustomElementBcmListbox } from './bcm-listbox.js';
export { BcmListboxGroup, defineCustomElement as defineCustomElementBcmListboxGroup } from './bcm-listbox-group.js';
export { BcmListboxItem, defineCustomElement as defineCustomElementBcmListboxItem } from './bcm-listbox-item.js';
export { BcmMenu, defineCustomElement as defineCustomElementBcmMenu } from './bcm-menu.js';
export { BcmMessage, defineCustomElement as defineCustomElementBcmMessage } from './bcm-message.js';
export { BcmModal, defineCustomElement as defineCustomElementBcmModal } from './bcm-modal.js';
export { BcmModal2, defineCustomElement as defineCustomElementBcmModal2 } from './bcm-modal-2.js';
export { BcmModal2Footer, defineCustomElement as defineCustomElementBcmModal2Footer } from './bcm-modal-2-footer.js';
export { BcmModal2Header, defineCustomElement as defineCustomElementBcmModal2Header } from './bcm-modal-2-header.js';
export { BcmNotification, defineCustomElement as defineCustomElementBcmNotification } from './bcm-notification.js';
export { BcmNumberInput, defineCustomElement as defineCustomElementBcmNumberInput } from './bcm-number-input.js';
export { BcmOldInput, defineCustomElement as defineCustomElementBcmOldInput } from './bcm-old-input.js';
export { BcmOldSearch, defineCustomElement as defineCustomElementBcmOldSearch } from './bcm-old-search.js';
export { BcmOldTag, defineCustomElement as defineCustomElementBcmOldTag } from './bcm-old-tag.js';
export { BcmOverlay, defineCustomElement as defineCustomElementBcmOverlay } from './bcm-overlay.js';
export { BcmPopconfirm, defineCustomElement as defineCustomElementBcmPopconfirm } from './bcm-popconfirm.js';
export { BcmPopconfirmBox, defineCustomElement as defineCustomElementBcmPopconfirmBox } from './bcm-popconfirm-box.js';
export { BcmPopover, defineCustomElement as defineCustomElementBcmPopover } from './bcm-popover.js';
export { BcmProgress, defineCustomElement as defineCustomElementBcmProgress } from './bcm-progress.js';
export { BcmRadio, defineCustomElement as defineCustomElementBcmRadio } from './bcm-radio.js';
export { BcmRadioGroup, defineCustomElement as defineCustomElementBcmRadioGroup } from './bcm-radio-group.js';
export { BcmRange, defineCustomElement as defineCustomElementBcmRange } from './bcm-range.js';
export { BcmRcOverflow, defineCustomElement as defineCustomElementBcmRcOverflow } from './bcm-rc-overflow.js';
export { BcmRcPicker, defineCustomElement as defineCustomElementBcmRcPicker } from './bcm-rc-picker.js';
export { BcmReactNumber, defineCustomElement as defineCustomElementBcmReactNumber } from './bcm-react-number.js';
export { BcmResult, defineCustomElement as defineCustomElementBcmResult } from './bcm-result.js';
export { BcmScrollArea, defineCustomElement as defineCustomElementBcmScrollArea } from './bcm-scroll-area.js';
export { BcmSearch, defineCustomElement as defineCustomElementBcmSearch } from './bcm-search.js';
export { BcmSelect, defineCustomElement as defineCustomElementBcmSelect } from './bcm-select.js';
export { BcmSelectBox, defineCustomElement as defineCustomElementBcmSelectBox } from './bcm-select-box.js';
export { BcmSelectGroup, defineCustomElement as defineCustomElementBcmSelectGroup } from './bcm-select-group.js';
export { BcmSelectOption, defineCustomElement as defineCustomElementBcmSelectOption } from './bcm-select-option.js';
export { BcmShortcut, defineCustomElement as defineCustomElementBcmShortcut } from './bcm-shortcut.js';
export { BcmSkeleton, defineCustomElement as defineCustomElementBcmSkeleton } from './bcm-skeleton.js';
export { BcmStep, defineCustomElement as defineCustomElementBcmStep } from './bcm-step.js';
export { BcmStepper, defineCustomElement as defineCustomElementBcmStepper } from './bcm-stepper.js';
export { BcmSwitch, defineCustomElement as defineCustomElementBcmSwitch } from './bcm-switch.js';
export { BcmTab, defineCustomElement as defineCustomElementBcmTab } from './bcm-tab.js';
export { BcmTabGroup, defineCustomElement as defineCustomElementBcmTabGroup } from './bcm-tab-group.js';
export { BcmTabItem, defineCustomElement as defineCustomElementBcmTabItem } from './bcm-tab-item.js';
export { BcmTabItemHeader, defineCustomElement as defineCustomElementBcmTabItemHeader } from './bcm-tab-item-header.js';
export { BcmTabPane, defineCustomElement as defineCustomElementBcmTabPane } from './bcm-tab-pane.js';
export { BcmTabs, defineCustomElement as defineCustomElementBcmTabs } from './bcm-tabs.js';
export { BcmTabsContent, defineCustomElement as defineCustomElementBcmTabsContent } from './bcm-tabs-content.js';
export { BcmTag, defineCustomElement as defineCustomElementBcmTag } from './bcm-tag.js';
export { BcmText, defineCustomElement as defineCustomElementBcmText } from './bcm-text.js';
export { BcmTextarea, defineCustomElement as defineCustomElementBcmTextarea } from './bcm-textarea.js';
export { BcmTimePicker, defineCustomElement as defineCustomElementBcmTimePicker } from './bcm-time-picker.js';
export { BcmTimeline, defineCustomElement as defineCustomElementBcmTimeline } from './bcm-timeline.js';
export { BcmTimelineItem, defineCustomElement as defineCustomElementBcmTimelineItem } from './bcm-timeline-item.js';
export { BcmToast, defineCustomElement as defineCustomElementBcmToast } from './bcm-toast.js';
export { BcmTooltip, defineCustomElement as defineCustomElementBcmTooltip } from './bcm-tooltip.js';
export { BcmTreeview, defineCustomElement as defineCustomElementBcmTreeview } from './bcm-treeview.js';
export { BcmTreeviewGroup, defineCustomElement as defineCustomElementBcmTreeviewGroup } from './bcm-treeview-group.js';
export { BcmTreeviewItem, defineCustomElement as defineCustomElementBcmTreeviewItem } from './bcm-treeview-item.js';
export { BcmTypography, defineCustomElement as defineCustomElementBcmTypography } from './bcm-typography.js';
export { OldBcmPopover, defineCustomElement as defineCustomElementOldBcmPopover } from './old-bcm-popover.js';
export { OldBcmPopoverBox, defineCustomElement as defineCustomElementOldBcmPopoverBox } from './old-bcm-popover-box.js';

window.bcm = (function () {
  return {
    version: version,
  };
})();
function addHeadScript(obj) {
  const head = document.head;
  const script = document.createElement("script");
  Object.keys(obj).forEach(key => {
    script[key] = obj[key];
  });
  head.appendChild(script);
}
addHeadScript({ src: "https://kit.fontawesome.com/5e86bea963.js", crossOrigin: "anonymous" });
(() => {
  LicenseManager.setLicenseKey(Env["AG_GRID_LICENSE_KEY"]);
})();
