/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { E as Env } from './index-0615c2b8.js';
import { v as version } from './package-7549581c.js';
import { L as LicenseManager } from './watermark-f2c6a1f9.js';

window.bcm = (function () {
  return {
    version: version,
  };
})();
function addHeadScript(obj) {
  const head = document.head;
  const script = document.createElement("script");
  Object.keys(obj).forEach(key => {
    script[key] = obj[key];
  });
  head.appendChild(script);
}
addHeadScript({ src: "https://kit.fontawesome.com/5e86bea963.js", crossOrigin: "anonymous" });
(() => {
  LicenseManager.setLicenseKey(Env["AG_GRID_LICENSE_KEY"]);
})();
