/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from './index-0615c2b8.js';
import { S as StringHelper } from './string-helper-3592bdc2.js';

const SlotTemplate = ({ value, className, name }) => {
  return StringHelper.isNullOrEmpty(value) ? h("span", { class: className },
    h("slot", Object.assign({}, (name && { name: name })))) : h("span", { class: className, innerHTML: value });
};

export { SlotTemplate as S };
