import { ShapeTypes, SizeTypes, StatusTypes } from "../../../models";
import { ComponentInterface } from "../../../stencil-public-runtime";
export declare class BcmAvatar implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  image: string;
  name: string;
  alt: string;
  shape: ShapeTypes;
  size: SizeTypes;
  color: string;
  icon: string;
  status: StatusTypes;
  blink: boolean;
  isFallback: boolean;
  getFirstLetters(name: string): string;
  renderDefaultIcon(): any;
  render(): any;
}
