import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmChip implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  type: "default" | "dismissable" | "addable" | "checkable";
  size: "small" | "medium" | "large";
  avatar: any;
  icon: any;
  disabled: false;
  color: any;
  selected: boolean;
  value: string;
  data: any;
  bcmChipDismiss: EventEmitter;
  bcmChipSelect: EventEmitter;
  bcmChipAddable: EventEmitter;
  bcmChipSelectItem: EventEmitter;
  setColor(): {
    "--bcm-chip-color": string;
    "--bcm-chip-color-hover": string;
    "--bcm-chip-color-focus": string;
    "--bcm-chip-color-active": string;
    "--bcm-chip-color-disabled": string;
    "--bcm-chip-background-color": string;
    "--bcm-chip-background-color-hover": string;
    "--bcm-chip-background-color-focus": string;
    "--bcm-chip-background-color-active": string;
    "--bcm-chip-background-color-disabled": string;
  };
  private handleDismiss;
  private handleAddable;
  listSelectedItems(e: any): void;
  render(): any;
}
