import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
import { DirectionTypes, SizeTypes } from '../../../models/bcm-types';
export declare class BcmButtonGroup implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  size: SizeTypes;
  type: 'checkbox' | 'radio' | 'button';
  color: any;
  disabled: any;
  direction: DirectionTypes;
  bcmChange: EventEmitter;
  componentWillLoad(): void;
  private getButtons;
  private radioControl;
  private checkboxControl;
  listenButton({ target }: {
    target: any;
  }): void;
  private handleChange;
  render(): any;
}
