import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
export declare class BcmExpansionPanel implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  expanded: boolean;
  disabled: boolean;
  hidden: boolean;
  valid: boolean;
  hideToggle: boolean;
  expandIconPosition: 'right' | 'left';
  headerColor: string;
  tooltip: any;
  tooltipDefaultValue: {
    message: string;
    placement: string;
    trigger: string;
    icon: string;
    color: string;
  };
  bcmOpen: EventEmitter;
  bcmClose: EventEmitter;
  bcmExtra: EventEmitter;
  componentWillRender(): void | Promise<void>;
  componentDidLoad(): void;
  private createTooltip;
  private checkExpanded;
  private restoreSlots;
  private toggle;
  private clickExtra;
  render(): any;
}
