export declare const inputStyle: import("tailwind-variants").TVReturnType<{
  size: {
    small: {
      host: string;
      inputContainer: string;
      input: string;
    };
    medium: {
      host: string;
      inputContainer: string;
      input: string;
    };
    large: {
      host: string;
      inputContainer: string;
      input: string;
    };
  };
  fullWidth: {
    true: {
      host: string;
    };
  };
  noMargin: {
    true: {
      host: string;
    };
  };
  hidden: {
    true: {
      host: string;
    };
  };
  focused: {
    true: {
      host: string;
    };
  };
  clearable: {
    true: {
      host: string;
    };
  };
  disabled: {
    true: {
      host: string;
      input: string;
      inputContainer: string;
      controlsBtn: string;
    };
    false: {
      controlsBtn: string;
      inputContainer: string[];
    };
  };
  readonly: {
    true: {
      host: string;
    };
  };
  invalid: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
  unit: {
    true: {
      host: string;
    };
  };
  error: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
}, {
  host: string;
  base: string;
  inputContainer: string[];
  input: string[];
  slotClass: string;
  clearButton: string[];
  controls: string;
  controlsBtn: string[];
  controlsBtnUp: string;
  controlsBtnDown: string;
  controlsDivider: string;
}, undefined, import("tailwind-variants/dist/config").TVConfig<{
  size: {
    small: {
      host: string;
      inputContainer: string;
      input: string;
    };
    medium: {
      host: string;
      inputContainer: string;
      input: string;
    };
    large: {
      host: string;
      inputContainer: string;
      input: string;
    };
  };
  fullWidth: {
    true: {
      host: string;
    };
  };
  noMargin: {
    true: {
      host: string;
    };
  };
  hidden: {
    true: {
      host: string;
    };
  };
  focused: {
    true: {
      host: string;
    };
  };
  clearable: {
    true: {
      host: string;
    };
  };
  disabled: {
    true: {
      host: string;
      input: string;
      inputContainer: string;
      controlsBtn: string;
    };
    false: {
      controlsBtn: string;
      inputContainer: string[];
    };
  };
  readonly: {
    true: {
      host: string;
    };
  };
  invalid: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
  unit: {
    true: {
      host: string;
    };
  };
  error: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
}, {
  size: {
    small: {
      host: string;
      inputContainer: string;
      input: string;
    };
    medium: {
      host: string;
      inputContainer: string;
      input: string;
    };
    large: {
      host: string;
      inputContainer: string;
      input: string;
    };
  };
  fullWidth: {
    true: {
      host: string;
    };
  };
  noMargin: {
    true: {
      host: string;
    };
  };
  hidden: {
    true: {
      host: string;
    };
  };
  focused: {
    true: {
      host: string;
    };
  };
  clearable: {
    true: {
      host: string;
    };
  };
  disabled: {
    true: {
      host: string;
      input: string;
      inputContainer: string;
      controlsBtn: string;
    };
    false: {
      controlsBtn: string;
      inputContainer: string[];
    };
  };
  readonly: {
    true: {
      host: string;
    };
  };
  invalid: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
  unit: {
    true: {
      host: string;
    };
  };
  error: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
}>, {
  size: {
    small: {
      host: string;
      inputContainer: string;
      input: string;
    };
    medium: {
      host: string;
      inputContainer: string;
      input: string;
    };
    large: {
      host: string;
      inputContainer: string;
      input: string;
    };
  };
  fullWidth: {
    true: {
      host: string;
    };
  };
  noMargin: {
    true: {
      host: string;
    };
  };
  hidden: {
    true: {
      host: string;
    };
  };
  focused: {
    true: {
      host: string;
    };
  };
  clearable: {
    true: {
      host: string;
    };
  };
  disabled: {
    true: {
      host: string;
      input: string;
      inputContainer: string;
      controlsBtn: string;
    };
    false: {
      controlsBtn: string;
      inputContainer: string[];
    };
  };
  readonly: {
    true: {
      host: string;
    };
  };
  invalid: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
  unit: {
    true: {
      host: string;
    };
  };
  error: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
}, {
  host: string;
  base: string;
  inputContainer: string[];
  input: string[];
  slotClass: string;
  clearButton: string[];
  controls: string;
  controlsBtn: string[];
  controlsBtnUp: string;
  controlsBtnDown: string;
  controlsDivider: string;
}, import("tailwind-variants").TVReturnType<{
  size: {
    small: {
      host: string;
      inputContainer: string;
      input: string;
    };
    medium: {
      host: string;
      inputContainer: string;
      input: string;
    };
    large: {
      host: string;
      inputContainer: string;
      input: string;
    };
  };
  fullWidth: {
    true: {
      host: string;
    };
  };
  noMargin: {
    true: {
      host: string;
    };
  };
  hidden: {
    true: {
      host: string;
    };
  };
  focused: {
    true: {
      host: string;
    };
  };
  clearable: {
    true: {
      host: string;
    };
  };
  disabled: {
    true: {
      host: string;
      input: string;
      inputContainer: string;
      controlsBtn: string;
    };
    false: {
      controlsBtn: string;
      inputContainer: string[];
    };
  };
  readonly: {
    true: {
      host: string;
    };
  };
  invalid: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
  unit: {
    true: {
      host: string;
    };
  };
  error: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
}, {
  host: string;
  base: string;
  inputContainer: string[];
  input: string[];
  slotClass: string;
  clearButton: string[];
  controls: string;
  controlsBtn: string[];
  controlsBtnUp: string;
  controlsBtnDown: string;
  controlsDivider: string;
}, undefined, import("tailwind-variants/dist/config").TVConfig<{
  size: {
    small: {
      host: string;
      inputContainer: string;
      input: string;
    };
    medium: {
      host: string;
      inputContainer: string;
      input: string;
    };
    large: {
      host: string;
      inputContainer: string;
      input: string;
    };
  };
  fullWidth: {
    true: {
      host: string;
    };
  };
  noMargin: {
    true: {
      host: string;
    };
  };
  hidden: {
    true: {
      host: string;
    };
  };
  focused: {
    true: {
      host: string;
    };
  };
  clearable: {
    true: {
      host: string;
    };
  };
  disabled: {
    true: {
      host: string;
      input: string;
      inputContainer: string;
      controlsBtn: string;
    };
    false: {
      controlsBtn: string;
      inputContainer: string[];
    };
  };
  readonly: {
    true: {
      host: string;
    };
  };
  invalid: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
  unit: {
    true: {
      host: string;
    };
  };
  error: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
}, {
  size: {
    small: {
      host: string;
      inputContainer: string;
      input: string;
    };
    medium: {
      host: string;
      inputContainer: string;
      input: string;
    };
    large: {
      host: string;
      inputContainer: string;
      input: string;
    };
  };
  fullWidth: {
    true: {
      host: string;
    };
  };
  noMargin: {
    true: {
      host: string;
    };
  };
  hidden: {
    true: {
      host: string;
    };
  };
  focused: {
    true: {
      host: string;
    };
  };
  clearable: {
    true: {
      host: string;
    };
  };
  disabled: {
    true: {
      host: string;
      input: string;
      inputContainer: string;
      controlsBtn: string;
    };
    false: {
      controlsBtn: string;
      inputContainer: string[];
    };
  };
  readonly: {
    true: {
      host: string;
    };
  };
  invalid: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
  unit: {
    true: {
      host: string;
    };
  };
  error: {
    true: {
      host: string;
      inputContainer: string;
    };
  };
}>, unknown, unknown, undefined>>;
