import { PlacementTypes, TrigglerTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmLinked implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  placement: PlacementTypes;
  trigger: TrigglerTypes;
  targetId: string;
  height: string;
  maxHeight: string;
  minHeight: string;
  isOpen: boolean;
  hideDelay: number;
  moveOverLayContainer: boolean;
  bcmOpen: EventEmitter;
  isMouseOverLink: boolean;
  constructor();
  private timeoutId;
  private target;
  private detectClone;
  private dismissEvent;
  private checkDataDismiss;
  private hideChildLinked;
  private calculatePosition;
  init(): void;
  componentDidLoad(): void;
  triggerWatch(newValue: TrigglerTypes): void;
  watchIsOpen(): void;
  onLinkedDataDismis(): void;
  onBcmFloatingIsHide(e: any): void;
  show(wait?: boolean): Promise<boolean>;
  hide(wait?: boolean): Promise<boolean>;
  toggle(wait?: boolean): Promise<boolean>;
  clickListener(e: any): void;
  private listenMouseOver;
  private handleMouseLeave;
  private handleMouseEnter;
  render(): any;
}
