import { EventEmitter, ComponentInterface } from '../../../stencil-public-runtime';
export declare class BcmModal implements ComponentInterface {
  el: HTMLElement;
  modalSlots: {};
  _id: string;
  isShow: boolean;
  hidden: boolean;
  size: any;
  backdrop: boolean | 'static';
  width: string;
  height: string;
  fullWidth: boolean;
  close: EventEmitter;
  modalClose: EventEmitter;
  modalBeforeClose: EventEmitter;
  modalBeforeOpen: EventEmitter;
  connectedCallback(): void;
  componentWillLoad(): void;
  handleSubmit(e: any): void;
  handleBackdrop(): void;
  hide(obj?: {
    force: boolean;
  }): Promise<void>;
  show(obj?: {
    force: boolean;
  }): Promise<void>;
  keyboardNavigation(e: any): void;
  showModal(e: any): Promise<void>;
  hideModal(e: any): Promise<void>;
  _openHandler(): void;
  disconnectedCallback(): void;
  render(): any;
}
