import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
import { SizeTypes } from '../../../models/bcm-types';
export declare class BcmSearch implements ComponentInterface {
  el: HTMLElement;
  inputElement: HTMLInputElement;
  _id: string;
  placeholder: string;
  disabled: boolean;
  readonly: boolean;
  clearable: boolean;
  size: SizeTypes;
  limit: number;
  searchIsOnlyChilds: boolean;
  minSearchLength: number;
  data: any;
  tick: {};
  isActiveClearable: boolean;
  bcmOnSearch: EventEmitter;
  bcmOnSearchClear: EventEmitter;
  debounceHandler: () => void;
  componentDidLoad(): Promise<void>;
  dataChanged(newValue: any, oldValue: any): Promise<void>;
  private initState;
  private markForCheck;
  handleInput(): void;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  onBcmSelect(): Promise<void>;
  setValue(newValue: any): Promise<void>;
  handleFocus(): void;
  handleBlur(): void;
  handleChange(): void;
  handleClear(eventEmit?: boolean): Promise<void>;
  onSearchValue(event: any, instance: any): void;
  render(): any;
}
