import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
export declare class BcmStep implements ComponentInterface {
  el: HTMLElement;
  hidden: boolean;
  _id: string;
  _title: string;
  description: string;
  status: 'default' | 'success' | 'warning' | 'error';
  icon: string;
  loading: boolean;
  valid: boolean;
  index: number;
  active: boolean;
  htmlTemplate: string;
  isLast: boolean;
  disabled: boolean;
  dataIsLoaded: EventEmitter;
  bcmChangeHidden: EventEmitter;
  componentDidLoad(): void;
  getStepper(): any;
  activeChanged(): void;
  statusChange(): void;
  hiddenChange(newValue: any, oldValue: any): void;
  disabledChange(newValue: any, _: any): void;
  render(): any;
}
