import { DirectionTypes, SizeTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmStepper implements ComponentInterface {
  el: HTMLElement;
  hidden: boolean;
  _id: string;
  direction: DirectionTypes;
  linear: boolean;
  size: SizeTypes;
  icon: boolean;
  active: number;
  stepperId: string;
  data: any[];
  tick: {};
  bcmStepChange: EventEmitter;
  bcmStepperBeforeChange: EventEmitter;
  dataChanged(): Promise<void>;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  private initState;
  componentDidRender(): void;
  setSteps(steps: any): void;
  markForCheck(): void;
  handleChangeBcmHidden(): void;
  private getActiveIndex;
  private getSlotElements;
  onStepChange(index?: any): Promise<any>;
  prev(): Promise<any>;
  next(idx?: number): Promise<any>;
  setActive(index: number): Promise<void>;
  reset(): Promise<any>;
  getCurrentStep(): Promise<any>;
  getSteps(): Promise<any[]>;
  private getItems;
  private headerClick;
  handleBcmStepBeforeChange(e: CustomEvent): Promise<void>;
  render(): any;
}
