import { SizeTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmTabGroup implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  active: string;
  color: string;
  size: SizeTypes;
  tabChange: EventEmitter;
  get tabItems(): NodeListOf<HTMLBcmTabItemElement>;
  get tabItemHeaders(): NodeListOf<HTMLBcmTabItemHeaderElement>;
  setTabAttributes(): void;
  componentWillLoad(): void | Promise<void>;
  handleTabClick(index?: any): void;
  componentDidRender(): void;
  componentDidLoad(): void;
  setActive(index: number): Promise<void>;
  refresh(): Promise<void>;
  inkBarControl(): void;
  activeChanged(newVal: string, _oldVal: string): void;
  observer: MutationObserver;
  observeTabItem(): void;
  tabProcess(): void;
  updateTabHeaders(): void;
  regenerateIndex(): void;
  render(): any;
}
