import { EventEmitter } from '../../../stencil-public-runtime';
export declare class BcmAutocomplete {
  el: HTMLElement;
  private bcmListbox;
  objectMapping: object;
  searchFields: Array<string>;
  _items: Array<object> | string;
  fullWidth: boolean;
  hidden: boolean;
  searchText: string;
  returnField: string;
  searchSub: string;
  searchPlaceholder: string;
  inputLength: Number;
  isOpen: boolean;
  resultFound: boolean;
  searchData: any;
  searchResults: any;
  items: Array<object>;
  autocompleteItemSelected: EventEmitter;
  config(_config: Array<object>): Promise<void>;
  setData(_data?: Array<object> | string): Promise<void>;
  /**
   * @desc
   */
  handleListboxClearSelected(e: any): Promise<void>;
  listenSearchValue(e: any): void;
  listenSearchResult(e: any): Promise<void>;
  handleClickOutside(e: MouseEvent): void;
  render(): any;
}
