import { EventEmitter } from '../../../stencil-public-runtime';
export declare class BcmForm {
  el: HTMLElement;
  private formData;
  private inputs;
  private duplicateInput;
  private selector;
  private isValid;
  private returnCaption;
  private Bromcom;
  _id: string;
  hidden: boolean;
  validation: boolean;
  name: string;
  value: any;
  autocomplete: boolean;
  bcmForm: EventEmitter;
  handleSubmit(): void;
  submitFunction(): Promise<any>;
  submit(): Promise<any>;
  set(data: object): Promise<void>;
  get(): Promise<{}>;
  setClear(): Promise<boolean>;
  resetCaption(): Promise<void>;
  config(_config: Array<object>): Promise<boolean>;
  getInputs(): Promise<void>;
  getItemValue(item: any): any;
  isWrapperComponent(item: string): boolean;
  isGroupComponent(item: string): boolean;
  isListComponent(item: string): boolean;
  userFormData(): Promise<any>;
  handleChange(e: any): Promise<void>;
  handleSubmitForm(e: any): Promise<void>;
  render(): any;
}
