import { EventEmitter } from '../../../stencil-public-runtime';
export declare class BcmOldInput {
  el: HTMLElement;
  inputId: string;
  inputElement: HTMLInputElement;
  type: string;
  value: any;
  size: 'small' | 'medium' | 'large';
  label: string;
  noCaption: boolean;
  noMargin: boolean;
  captionError: string;
  caption: string;
  captionType: 'primary' | 'success' | 'warning' | 'error' | 'default';
  placeholder: string;
  fullWidth: boolean;
  disabled: boolean;
  readonly: boolean;
  clearable: boolean;
  passwordToggle: boolean;
  noDefaultIcon: boolean;
  _id: string;
  _internal_id: string;
  name: string;
  unit: string;
  unitPrefix: string;
  decimal: any;
  min: number;
  max: number;
  step: any;
  hidden: boolean;
  required: boolean;
  disableWatchValue: boolean;
  maxLength: number;
  tooltip: string;
  inValid: boolean;
  valueCache: string;
  captionCache: string;
  captionTypeCache: any;
  hasFocus: boolean;
  isBlur: boolean;
  isPasswordVisible: boolean;
  focus: EventEmitter;
  blur: EventEmitter;
  clear: EventEmitter;
  change: EventEmitter;
  input: EventEmitter;
  setFocus(): Promise<void>;
  removeFocus(): Promise<void>;
  select(): Promise<void>;
  setValue(value: any): Promise<any>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  getValue(): Promise<any>;
  handleFocus(): void;
  handleBlur(): void;
  handleChange(): void;
  handleInput(): void;
  handleClear(e: MouseEvent): void;
  changePasswordVisibility(): void;
  incrementNumber(): void;
  decrementNumber(): void;
  getNumberStep(step?: number): number;
  connectedCallback(): void;
  validationRange(val?: string): boolean;
  setCaption(caption?: any, captionType?: any): void;
  isEmailValid(): boolean;
  isTelValid(): boolean;
  isNumberValid(caption?: string, captionType?: string): boolean;
  setNumberUnit(): void;
  numberDecimal(val?: string): string;
  numberNotDecimal(val?: number): number;
  getDecimalLength(): number;
  componentWillRender(): void;
  componentWillLoad(): void;
  numberControl(e: any): boolean;
  whatchHasFocus(): void;
  watchValue(): void;
  render(): any;
}
