import { EventEmitter } from '../../../stencil-public-runtime';
import { ColorPaletteTypes, FontSizesTypes, TagTypes } from '../../../models/bcm-types';
export declare class BcmTag {
  el: HTMLElement;
  _id: string;
  _internal_id: string;
  hidden: boolean;
  value: string;
  type: TagTypes;
  checked: boolean;
  color: ColorPaletteTypes;
  customStyle: any;
  itemObject: string;
  size: FontSizesTypes | number;
  change: EventEmitter;
  tagDismissable: EventEmitter;
  bcmTagSelect: EventEmitter;
  closeFunc: Function;
  selectFunc: Function;
  handleClick(): void;
  handleClose(): void;
  handleChecked(): void;
  render(): any;
}
