export declare class Popover {
  id?: string;
  content?: string;
  message?: string;
  targetId?: string;
  placement?: any;
  color?: string;
  el?: HTMLElement;
  trigger?: string;
  openDelay: number;
  closeDelay: number;
  autoHide?: boolean;
  emitShow: () => void;
  emitHide: () => void;
  constructor({ content, message, targetId, placement, color, trigger, openDelay, closeDelay, autoHide, emitShow, emitHide }: {
    content: any;
    message: any;
    targetId: any;
    placement?: string;
    color?: string;
    trigger?: string;
    openDelay?: number;
    closeDelay?: number;
    autoHide?: boolean;
    emitShow?: () => void;
    emitHide?: () => void;
  });
  destroy: () => void;
  private target;
  private init;
  update: () => void;
  listener: () => void;
  removeListener: () => void;
  private calculatePosition;
  show: () => Promise<void>;
  hide: () => Promise<void>;
  toggle: () => void;
}
