export declare abstract class KeyControl {
  private keyCode;
  private element;
  private elementName;
  private childElementName;
  constructor(keyCode: number, element: HTMLElement, elementName?: string, childElementName?: string);
  protected abstract keyDown?(): void;
  protected abstract keyUp?(): void;
  protected getKeyCode(): number;
  protected getElementName(): string;
  protected getChildElementName(): string;
  protected getFocusedElementName(): string;
  protected getFocusedElement(): any;
  protected getFirstElement(): Element;
  protected getNextElement(): any;
  protected getPreviousElement(): any;
  protected getChildElement(): any;
  protected getParentElement(element: any): any;
  protected focusElementIsOpen(): any;
  protected isRootElement(): boolean;
  protected isRootElementIsOpen(): any;
  protected getFocusedChildElement(): any;
  protected isLastElement(): boolean;
  protected focusParentElementFirstChild(): void;
  protected isFirstElement(): boolean;
  protected focusRootElement(): void;
  protected nextRootElement(): void;
  protected findFocusElementParent(): any;
  protected getLastElement(): Element;
  protected setFocus(element: any): void;
}
