import Bcm from "./bcm";
export declare type SizeTypes = 'small' | 'medium' | 'large';
export declare type FullSizeTypes = SizeTypes | 'xsmall' | 'xlarge' | 'xxlarge' | 'xxxlarge';
export declare type KindTypes = keyof typeof Bcm.Kind;
export declare type ShapeTypes = keyof typeof Bcm.Shape;
export declare type HtmlElementTypes = keyof typeof Bcm.HtmlElementType;
export declare type StatusTypes = keyof typeof Bcm.Status;
export declare type ButtonTypes = keyof typeof Bcm.ButtonType;
export declare type IconPositionTypes = keyof typeof Bcm.IconPosition;
export declare type DirectionTypes = keyof typeof Bcm.Direction;
export declare type TagTypes = keyof typeof Bcm.TagType;
export declare type FontSizesTypes = keyof typeof Bcm.FontSize;
export declare type FontWeightTypes = keyof typeof Bcm.FontWeight;
export declare type ColorPaletteTypes = keyof typeof Bcm.ColorPalette;
export declare type PreDefinedIconSizes = keyof typeof Bcm.PreDefinedIconSize;
export declare type InputTypes = keyof typeof Bcm.InputType;
export declare type IndeterminateTypes = keyof typeof Bcm.IndeterminateType;
export declare type PlacementTypes = keyof typeof Bcm.Placement;
export declare type PositionTypes = keyof typeof Bcm.Position;
export declare type TrigglerTypes = keyof typeof Bcm.TriggerType;
export declare type ListTypes = keyof typeof Bcm.ListType;
