export declare namespace BcmOrganismsState {
  interface GenerateId {
    id: string;
  }
  interface Options {
    type?: any;
    treeview?: any;
    checkboxes?: any;
    searchable?: any;
    value?: any;
    name?: any;
    label?: any;
    size?: any;
    disabled?: any;
    readonly?: any;
    highlight?: any;
    required?: any;
    hidden?: any;
    fullWidth?: any;
    height?: any;
    maxHeight?: any;
    minHeight?: any;
    width?: any;
    infoFooter?: any;
    variableText?: any;
    template?: any;
    allOpen?: any;
    keyControl?: any;
    checkAll?: any;
    linkedComponent?: any;
    placeholder?: any;
    searchPlaceholder?: any;
    searchIsOnlyChilds?: any;
    clearable?: any;
    caption?: any;
    noCaption?: any;
    captionType?: any;
    captionError?: any;
    placement?: any;
  }
  interface Data extends GenerateId {
    size?: any;
    parentId?: any;
    text?: any;
    tooltipText?: any;
    secondaryText?: any;
    icon?: any;
    template?: any;
    avatar?: any;
    disabled?: any;
    readonly?: any;
    checked?: any;
    selected?: any;
    hidden?: any;
    checkboxes?: any;
    open?: any;
    isSearch?: any;
    highlight?: any;
    showIcon?: any;
    focused?: any;
    favicon?: any;
    indeterminate?: any;
    itemObject?: any;
    contextMenu?: any;
    inOther?: any;
    type?: any;
    items?: Data[];
  }
  interface TotalItem {
    total: number;
    selectableItems: number;
  }
  interface BcmList2Model extends GenerateId {
    dataSource: Data[];
    options: Options;
    totalItems: TotalItem;
    totalRoots: number;
    filterData?: Data[];
    isSearchOtherTag?: boolean;
  }
}
export default BcmOrganismsState;
